--------------------------------------------------------
-- Archivo creado  - lunes-junio-17-2013   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Type REPCAT$_OBJECT_NULL_VECTOR
--------------------------------------------------------

  CREATE OR REPLACE TYPE "SYSTEM"."REPCAT$_OBJECT_NULL_VECTOR" AS OBJECT
(
  -- type owner, name, hashcode for the type represented by null_vector
  type_owner      VARCHAR2(30),
  type_name       VARCHAR2(30),
  type_hashcode   RAW(17),
  -- null_vector for a particular object instance
  -- ROBJ REVISIT: should only contain the null image, and not version#
  null_vector     RAW(2000)
)

/
--------------------------------------------------------
--  DDL for Sequence SEQ_CONTRACTE_ID
--------------------------------------------------------

   CREATE SEQUENCE  "SYSTEM"."SEQ_CONTRACTE_ID"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_CONTRACTE_TEMPORADA_ID
--------------------------------------------------------

   CREATE SEQUENCE  "SYSTEM"."SEQ_CONTRACTE_TEMPORADA_ID"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_JUGADOR_ID
--------------------------------------------------------

   CREATE SEQUENCE  "SYSTEM"."SEQ_JUGADOR_ID"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_LOG_CRIDES_ID
--------------------------------------------------------

   CREATE SEQUENCE  "SYSTEM"."SEQ_LOG_CRIDES_ID"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Sequence SEQ_PARTIT_ID
--------------------------------------------------------

   CREATE SEQUENCE  "SYSTEM"."SEQ_PARTIT_ID"  MINVALUE 1 MAXVALUE 9999999999999999999999999999 INCREMENT BY 1 START WITH 1 CACHE 20 NOORDER  NOCYCLE ;
--------------------------------------------------------
--  DDL for Table ACTIVITAT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."ACTIVITAT" 
   (	"ACTIVITAT_ID" NUMBER(*,0), 
	"ACTIVITAT" VARCHAR2(7 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."ACTIVITAT"."ACTIVITAT_ID" IS 'Identificador d''activitat.';
   COMMENT ON COLUMN "SYSTEM"."ACTIVITAT"."ACTIVITAT" IS 'Indicador d''activitat del jugador. 1:Actiu, 2:Retirat.';
--------------------------------------------------------
--  DDL for Table AMBIT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."AMBIT" 
   (	"AMBIT_ID" NUMBER(*,0), 
	"AMBIT" VARCHAR2(11 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."AMBIT"."AMBIT_ID" IS 'Identificador de l''mbit.';
   COMMENT ON COLUMN "SYSTEM"."AMBIT"."AMBIT" IS '1 Nacional, 2 Continental.';
--------------------------------------------------------
--  DDL for Table ARBITRE
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."ARBITRE" 
   (	"ARBITRE_ID" NUMBER(*,0), 
	"ARBITRE" VARCHAR2(50 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."ARBITRE"."ARBITRE_ID" IS 'Identificador de l''rbitre.';
   COMMENT ON COLUMN "SYSTEM"."ARBITRE"."ARBITRE" IS 'rbitre.';
--------------------------------------------------------
--  DDL for Table CATEGORIA
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."CATEGORIA" 
   (	"CATEGORIA_ID" NUMBER(*,0), 
	"CATEGORIA" VARCHAR2(2 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."CATEGORIA"."CATEGORIA_ID" IS 'Identificador de categoria.';
   COMMENT ON COLUMN "SYSTEM"."CATEGORIA"."CATEGORIA" IS '1: 1, 2: 2';
--------------------------------------------------------
--  DDL for Table COMPETICIO
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."COMPETICIO" 
   (	"COMPETICIO_ID" NUMBER(*,0), 
	"COMPETICIO" VARCHAR2(40 CHAR), 
	"AMBIT_ID" NUMBER(*,0), 
	"GENERE_ID" NUMBER(*,0) DEFAULT 1, 
	"MODALITAT_ID" NUMBER(*,0) DEFAULT 1, 
	"PAIS_ID" NUMBER(*,0), 
	"CONTINENT_ID" NUMBER(*,0), 
	"N_ARBITRES" NUMBER(*,0), 
	"CATEGORIA_ID" NUMBER(*,0), 
	"TEMPORADA_ID" NUMBER(*,0), 
	"FACTOR_P" NUMBER(2,0), 
	"ANY_" NUMBER(*,0)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."COMPETICIO_ID" IS 'Identificador de competicio.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."COMPETICIO" IS 'Nom de la competici.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."AMBIT_ID" IS 'mbit de la competici, 1 Nacional, 2 Continental.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."GENERE_ID" IS 'Gnere de la competici. 1 Mascul, 2 Femen.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."MODALITAT_ID" IS 'Modalitat de la competici. 1 Normal, 2 Cadira de rodes.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."PAIS_ID" IS 'Pais de la competici en cas de ser nacional.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."CONTINENT_ID" IS 'Cotinent de la competici en cas de ser continental.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."N_ARBITRES" IS 'Nombre d''rbitres (a ms a ms de l''rbitre principal, en competicions nacionals hi haur dos auxiliars, i en continentals tres)';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."CATEGORIA_ID" IS 'Categoria de la competici. 1: 1, 2: 2';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."TEMPORADA_ID" IS 'Temporada de la competici.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."FACTOR_P" IS 'Factor p de ponderaci d''estadstiques, es multiplica a la valoraci del partit. El factor p est associat a cada competici. Per exemple, a la lliga ACB espanyola (primera divisi), el factor p pot ser de 10, mentre que a la lliga LEB Or espanyola (segona divisi), el factor pot ser 8.';
   COMMENT ON COLUMN "SYSTEM"."COMPETICIO"."ANY_" IS 'Any per a una competici. null per a una competici de temporada.';
--------------------------------------------------------
--  DDL for Table CONTINENT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."CONTINENT" 
   (	"CONTINENT_ID" NUMBER(*,0), 
	"CONTINENT" VARCHAR2(20 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."CONTINENT"."CONTINENT_ID" IS 'Identificador de continent.';
   COMMENT ON COLUMN "SYSTEM"."CONTINENT"."CONTINENT" IS '1: frica, 2: Amrica del Nord, 3: Amrica del Sud, 4: sia, 5: Antrtida, 6: Europa, 7: Oceania.';
--------------------------------------------------------
--  DDL for Table CONTRACTE
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."CONTRACTE" 
   (	"CONTRACTE_ID" NUMBER(*,0), 
	"DATA_SIGNATURA" DATE, 
	"JUGADOR_ID" NUMBER(*,0), 
	"EQUIP_COMPRADOR_ID" NUMBER(*,0), 
	"EQUIP_VENEDOR_ID" NUMBER(*,0), 
	"DURADA_CONTRACTE" NUMBER(2,0), 
	"SALARI_BRUT_ANUAL" NUMBER(8,2), 
	"COMPENSACIO_A_EQUIP_VENEDOR" NUMBER(8,2), 
	"VALOR_OPERACIO" NUMBER(9,2), 
	"REPRESENTANT_ID" NUMBER(*,0), 
	"DATA_FINAL_CONTRACTE" DATE, 
	"ULTIM" NUMBER(*,0) DEFAULT 1, 
	"PRIMERA_TEMPORADA_ID" NUMBER(*,0)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."CONTRACTE_ID" IS 'Identificador del contracte.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."DATA_SIGNATURA" IS 'Data de signatura del contracte.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."JUGADOR_ID" IS 'Jugador.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."EQUIP_COMPRADOR_ID" IS 'Equip comprador.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."EQUIP_VENEDOR_ID" IS 'Equip venedor.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."DURADA_CONTRACTE" IS 'Durada del contracte (en anys sencers)';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."SALARI_BRUT_ANUAL" IS 'Salari brut anual.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."COMPENSACIO_A_EQUIP_VENEDOR" IS 'Compensaci econmica a l''equip venedor.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."VALOR_OPERACIO" IS 'Valor econmic de l''operaci, definida com a compensaci econmica a l''equip venedor ms el salari brut.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."REPRESENTANT_ID" IS 'Representant del jugador contractat.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."DATA_FINAL_CONTRACTE" IS 'Data en la que finalitza el contracte.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."ULTIM" IS 'Indica que s l''ltim contracte. Valor 0: No, 1: S.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE"."PRIMERA_TEMPORADA_ID" IS 'Temporada a la que comena el contracte.';
--------------------------------------------------------
--  DDL for Table CONTRACTE_TEMPORADA
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."CONTRACTE_TEMPORADA" 
   (	"C_T_ID" NUMBER(*,0), 
	"CONTRACTE_ID" NUMBER(*,0), 
	"TEMPORADA_ID" NUMBER(*,0)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."CONTRACTE_TEMPORADA"."C_T_ID" IS 'Identificador del contracte de la temporada.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE_TEMPORADA"."CONTRACTE_ID" IS 'Contracte associat a la temporada.';
   COMMENT ON COLUMN "SYSTEM"."CONTRACTE_TEMPORADA"."TEMPORADA_ID" IS 'Temporada associada al contracte.';
--------------------------------------------------------
--  DDL for Table EQUIP
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."EQUIP" 
   (	"EQUIP_ID" NUMBER(*,0), 
	"EQUIP" VARCHAR2(75 CHAR), 
	"REPRESENTANT_LEGAL" VARCHAR2(75 CHAR), 
	"MUNICIPI_PAVELLO" VARCHAR2(50 CHAR), 
	"PAIS_ID" NUMBER(*,0), 
	"ADREA" VARCHAR2(250 CHAR), 
	"TELEFON" VARCHAR2(25 CHAR), 
	"URL_WEB" VARCHAR2(250 CHAR), 
	"TIPUS_EQUIP_ID" NUMBER(*,0), 
	"N_SOCIS" NUMBER(*,0) DEFAULT 0, 
	"PRIMER_ENTRENADOR" VARCHAR2(75 CHAR), 
	"ENTRENADOR_AJUDANT" VARCHAR2(75 CHAR), 
	"PAVELLO" VARCHAR2(40 CHAR), 
	"GENERE_ID" NUMBER(*,0)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."EQUIP"."EQUIP_ID" IS 'Identificador de l''equip.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."EQUIP" IS 'Nom de l''equip.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."REPRESENTANT_LEGAL" IS 'representant legal de l''equip.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."MUNICIPI_PAVELLO" IS 'Municipi a on est l''equip.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."PAIS_ID" IS 'Pas a on est l''equip.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."ADREA" IS 'Adrea de les oficines entrals.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."TELEFON" IS 'Telfon.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."URL_WEB" IS 'URL a la pgina web.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."TIPUS_EQUIP_ID" IS 'Indicador de si s un club o una societat (annima, limitada, etc.)';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."N_SOCIS" IS 'Nmero de socis si s un club.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."PRIMER_ENTRENADOR" IS 'Nom del primer entrenador.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."ENTRENADOR_AJUDANT" IS 'Nom de l''entrenador ajudant. ';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."PAVELLO" IS 'Pavell al que juga els partits locals l''equip.';
   COMMENT ON COLUMN "SYSTEM"."EQUIP"."GENERE_ID" IS 'Gnere dels integrants de l''equip.';
--------------------------------------------------------
--  DDL for Table ESTADISTIQUES_P_J
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."ESTADISTIQUES_P_J" 
   (	"ESTADISTICA_ID" NUMBER(*,0), 
	"PARTIT_ID" NUMBER(*,0), 
	"JUGADOR_ID" NUMBER(*,0), 
	"MINUTS_JUGATS" NUMBER(*,0) DEFAULT 0, 
	"PT" NUMBER(*,0) DEFAULT 0, 
	"T1I" NUMBER(*,0) DEFAULT 0, 
	"T1E" NUMBER(*,0) DEFAULT 0, 
	"T2I" NUMBER(*,0) DEFAULT 0, 
	"T2E" NUMBER(*,0) DEFAULT 0, 
	"T3I" NUMBER(*,0) DEFAULT 0, 
	"T3E" NUMBER(*,0) DEFAULT 0, 
	"RD" NUMBER(*,0) DEFAULT 0, 
	"RO" NUMBER(*,0) DEFAULT 0, 
	"ASS" NUMBER(*,0) DEFAULT 0, 
	"TF" NUMBER(*,0) DEFAULT 0, 
	"TC" NUMBER(*,0) DEFAULT 0, 
	"PR" NUMBER(*,0) DEFAULT 0, 
	"PP" NUMBER(*,0) DEFAULT 0, 
	"FC" NUMBER(*,0) DEFAULT 0, 
	"FR" NUMBER(*,0) DEFAULT 0, 
	"V" NUMBER(*,0) DEFAULT 0, 
	"VP" NUMBER(*,0) DEFAULT 0
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."ESTADISTICA_ID" IS 'Identificador de l''estadstica.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."PARTIT_ID" IS 'Identificador del partit.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."JUGADOR_ID" IS 'Identificador del jugador.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."MINUTS_JUGATS" IS 'Nmero de minuts jugats durant el partit.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."PT" IS 'Punts.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."T1I" IS 'Llanaments lliures intentats.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."T1E" IS 'Llanaments lliures encistellats.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."T2I" IS 'Llanaments de dos punts intentats.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."T2E" IS 'Llanaments de dos punts encistellats.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."T3I" IS 'Llanaments de tres punts intentats.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."T3E" IS 'Llanaments de tres punts encistellats.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."RD" IS 'Rebots defensius.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."RO" IS 'Rebots ofensius.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."ASS" IS 'Assistncies.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."TF" IS 'Taps a favor.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."TC" IS 'Taps en contra.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."PR" IS 'Pilotes recuperades.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."PP" IS 'Pilotes perdudes.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."FC" IS 'Faltes comeses.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."FR" IS 'Faltes rebudes.';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."V" IS 'Valoraci del jugador. 
La valoraci es calcula segons la frmula 
V = PT + T1E + T2E + T3E + RD + RO + AS + TF + PR + FR - T1I - T2I - T3I - TC - PP - FC';
   COMMENT ON COLUMN "SYSTEM"."ESTADISTIQUES_P_J"."VP" IS 'Valoraci del jugador ponderada. Aquesta es calcula aplicant un factor (p) que es multiplica a la valoraci del partit. El factor p est associat a cada competici. Per exemple, a la lliga ACB espanyola (primera divisi), el factor p pot ser de 10, mentre que a la lliga LEB Or espanyola (segona divisi), el factor pot ser 8. Aix
s''utilitza per tal que la mateixa valoraci en dues competicions de nivell diferent no acabin tenint el mateix pes absolut.
VP = V * p';
--------------------------------------------------------
--  DDL for Table ESTAT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."ESTAT" 
   (	"ESTAT_ID" NUMBER(*,0), 
	"ESTAT" VARCHAR2(20 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."ESTAT"."ESTAT_ID" IS 'Identificador de l''estat del jugador.';
   COMMENT ON COLUMN "SYSTEM"."ESTAT"."ESTAT" IS 'Estat del jugador. 1: Alta, 2: Baixa.';
--------------------------------------------------------
--  DDL for Table GENERE
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."GENERE" 
   (	"GENERE_ID" NUMBER(*,0), 
	"GENERE" VARCHAR2(7 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."GENERE"."GENERE_ID" IS 'Identificador del gnere del jugador.';
   COMMENT ON COLUMN "SYSTEM"."GENERE"."GENERE" IS '1 Mascul, 2 Femen.';
--------------------------------------------------------
--  DDL for Table JUGADOR
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."JUGADOR" 
   (	"JUGADOR_ID" NUMBER(*,0), 
	"NACIONALITAT_ID" NUMBER(*,0), 
	"FEDERACIO_ID" NUMBER(*,0), 
	"NUMERO_FEDERAT" NUMBER(*,0), 
	"NOM" VARCHAR2(75 CHAR), 
	"DATA_NAIXEMENT" DATE, 
	"ALADA" NUMBER(*,0), 
	"PES" NUMBER(*,3), 
	"POSICIO_ID" NUMBER(*,0), 
	"REPRESENTANT_ID" NUMBER(*,0), 
	"URL_WEB" VARCHAR2(250 CHAR), 
	"URL_VIDEO_PROMOCIO" VARCHAR2(250 CHAR), 
	"ACTIVITAT_ID" NUMBER(*,0), 
	"ESTAT_ID" NUMBER(*,0), 
	"SUB_ESTAT_ID" NUMBER(*,0), 
	"DIAGNOSTIC" VARCHAR2(250 CHAR) DEFAULT NULL, 
	"DATA_DISPONIBILITAT" DATE, 
	"GENERE_ID" NUMBER(*,0), 
	"MODALITAT_ID" NUMBER(*,0)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."JUGADOR_ID" IS 'Identificador del jugador.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."NACIONALITAT_ID" IS 'Nacionalitat.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."FEDERACIO_ID" IS 'Federaci (pas).';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."NUMERO_FEDERAT" IS 'Nmero de federat.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."NOM" IS 'Noms i cognoms.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."DATA_NAIXEMENT" IS 'Data de naixement.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."ALADA" IS 'Alada.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."PES" IS 'Pes.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."POSICIO_ID" IS 'Posici on juga habitualment (1:base, 2:escorta, 3:aler, 4:aler-pivot, 5:pivot)';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."REPRESENTANT_ID" IS 'Identificador del representant.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."URL_WEB" IS 'URL opcional a la pgina web personal del jugador.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."URL_VIDEO_PROMOCIO" IS 'URL opcional que enllaci a un vdeo de promoci del jugador.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."ACTIVITAT_ID" IS 'Indicador d''activitat del jugador (actiu, retirat).';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."ESTAT_ID" IS 'Indica si est d''alta o baixa';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."SUB_ESTAT_ID" IS 'Indica si s baixa mdica o per motius personals';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."DIAGNOSTIC" IS 'Diagnstic actual en cas de baixa mdica.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."DATA_DISPONIBILITAT" IS 'Data estimada de disponibilitat del jugador en cas de baixa.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."GENERE_ID" IS 'Identificador de gnere.';
   COMMENT ON COLUMN "SYSTEM"."JUGADOR"."MODALITAT_ID" IS 'Modalitat del jugador, 1: normal, 2: cadira de rodes.';
--------------------------------------------------------
--  DDL for Table LOG_CRIDES
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."LOG_CRIDES" 
   (	"LOG_CRIDES_ID" NUMBER(*,0), 
	"PACKAGE" VARCHAR2(30 CHAR), 
	"PROCEDIMENT" VARCHAR2(30 CHAR), 
	"ENTRADA" VARCHAR2(500 CHAR), 
	"RSP" VARCHAR2(500 CHAR), 
	"INICI" TIMESTAMP (6), 
	"FI" TIMESTAMP (6)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."LOG_CRIDES"."LOG_CRIDES_ID" IS 'Identificador de la crida.';
   COMMENT ON COLUMN "SYSTEM"."LOG_CRIDES"."PACKAGE" IS 'Package cridat.';
   COMMENT ON COLUMN "SYSTEM"."LOG_CRIDES"."PROCEDIMENT" IS 'Procediment cridat.';
   COMMENT ON COLUMN "SYSTEM"."LOG_CRIDES"."ENTRADA" IS 'Parmetres d''entrada.';
   COMMENT ON COLUMN "SYSTEM"."LOG_CRIDES"."RSP" IS 'Parmetres de sortida. Indica si l''execuci ha finalitzat amb xit (valor OK) o si ha fracassat (valor ERROR + TIPUS DERROR)';
   COMMENT ON COLUMN "SYSTEM"."LOG_CRIDES"."INICI" IS 'Inici de la crida.';
   COMMENT ON COLUMN "SYSTEM"."LOG_CRIDES"."FI" IS 'Fi de la crida.';
--------------------------------------------------------
--  DDL for Table M_E_C1
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."M_E_C1" 
   (	"JUGADORS_ACTIUS" NUMBER(*,0)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."M_E_C1"."JUGADORS_ACTIUS" IS 'Nombre de jugadors en actiu.';
--------------------------------------------------------
--  DDL for Table M_E_C2
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."M_E_C2" 
   (	"COMPETICIO_ID" NUMBER(*,0), 
	"COMPETICIO" VARCHAR2(20 CHAR), 
	"TEMPORADA" VARCHAR2(20 CHAR), 
	"JUGADOR_ID" NUMBER(*,0), 
	"JUGADOR" VARCHAR2(20 CHAR), 
	"PUNTS" NUMBER(*,0) DEFAULT 0
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."M_E_C2"."COMPETICIO_ID" IS 'Identificador de competicio.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C2"."COMPETICIO" IS 'Nom de la competici.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C2"."TEMPORADA" IS 'Temporada de la competici.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C2"."JUGADOR_ID" IS 'Identificador del jugador.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C2"."JUGADOR" IS 'Nom del jugador.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C2"."PUNTS" IS 'Total de punts.';
--------------------------------------------------------
--  DDL for Table M_E_C3
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."M_E_C3" 
   (	"J_M1_G1" NUMBER(*,0), 
	"J_N_M1_G1" VARCHAR2(75 CHAR), 
	"S_M1_G1" NUMBER(*,2), 
	"J_M1_G2" NUMBER(*,0), 
	"J_N_M1_G2" VARCHAR2(75 CHAR), 
	"S_M1_G2" NUMBER(*,2), 
	"J_M2_G1" NUMBER(*,0), 
	"J_N_M2_G1" VARCHAR2(75 CHAR), 
	"S_M2_G1" NUMBER(*,2), 
	"J_M2_G2" NUMBER(*,0), 
	"J_N_M2_G2" VARCHAR2(75 CHAR), 
	"S_M2_G2" NUMBER(*,2)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_M1_G1" IS 'Identificador del jugador per a la modalitat normal i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_N_M1_G1" IS 'Nom del jugador per a la modalitat normal i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."S_M1_G1" IS 'Sou del jugador per a la modalitat normal i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_M1_G2" IS 'Identificador del jugador per a la modalitat normal i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_N_M1_G2" IS 'Nom del jugador per a la modalitat normal i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."S_M1_G2" IS 'Sou del jugador per a la modalitat normal i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_M2_G1" IS 'Identificador del jugador per a la modalitat Cadira de rodes i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_N_M2_G1" IS 'Nom del jugador per a la modalitat Cadira de rodes i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."S_M2_G1" IS 'Sou del jugador per a la modalitat Cadira de rodes i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_M2_G2" IS 'Identificador del jugador per a la modalitat Cadira de rodes i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."J_N_M2_G2" IS 'Nom del jugador per a la modalitat Cadira de rodes i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C3"."S_M2_G2" IS 'Sou del jugador per a la modalitat Cadira de rodes i gnere femen.';
--------------------------------------------------------
--  DDL for Table M_E_C4
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."M_E_C4" 
   (	"JUGADOR_ID" NUMBER(*,0), 
	"NOM" VARCHAR2(20 CHAR), 
	"GUANYS" NUMBER(*,2)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."M_E_C4"."JUGADOR_ID" IS 'Identificador del jugador.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C4"."NOM" IS 'Nom del jugador.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C4"."GUANYS" IS 'Guanys acumulats del jugador al llarg de la seva carrera esportiva.';
--------------------------------------------------------
--  DDL for Table M_E_C5
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."M_E_C5" 
   (	"PAIS_ID" NUMBER(*,0), 
	"TEMPORADA_ID" NUMBER(*,0), 
	"GENERE_ID" NUMBER(*,0), 
	"MODALITAT_ID" NUMBER(*,0), 
	"SOU_MIG_ANUAL" NUMBER(*,2) DEFAULT 0
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."M_E_C5"."PAIS_ID" IS 'Identificador de pas.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C5"."TEMPORADA_ID" IS 'Identificador de temporada.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C5"."GENERE_ID" IS 'Identificador de gnere.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C5"."MODALITAT_ID" IS 'Identificador de modalitat.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C5"."SOU_MIG_ANUAL" IS 'Sou mig anual dels jugadors del pas, la temporada, el gnere i la modalitat.';
--------------------------------------------------------
--  DDL for Table M_E_C6
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."M_E_C6" 
   (	"COMPETICIO_ID" NUMBER(*,2), 
	"COMPETICIO" VARCHAR2(40 CHAR), 
	"TEMPORADA_ID" NUMBER(*,2), 
	"TEMPORADA" VARCHAR2(20 CHAR), 
	"MILLOR_OFENSIU_ID" NUMBER(*,0), 
	"MILLOR_OFENSIU" VARCHAR2(75 CHAR), 
	"MILLOR_DEFENSIU_ID" NUMBER(*,0), 
	"MILLOR_DEFENSIU" VARCHAR2(75 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."COMPETICIO_ID" IS 'Identificador de la competicio.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."COMPETICIO" IS 'Nom de la competicio.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."TEMPORADA_ID" IS 'Identificador de la temporada.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."TEMPORADA" IS 'Nom de la temporada.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."MILLOR_OFENSIU_ID" IS 'Identificador del millor jugador ofensiu.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."MILLOR_OFENSIU" IS 'Nom del millor jugador ofensiu.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."MILLOR_DEFENSIU_ID" IS 'Identificador del millor jugador defensiu.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C6"."MILLOR_DEFENSIU" IS 'Nom del millor jugador defensiu.';
--------------------------------------------------------
--  DDL for Table M_E_C7
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."M_E_C7" 
   (	"J_ID_M1_G1" NUMBER(*,0), 
	"NOM_M1_G1" VARCHAR2(75 CHAR), 
	"MVP_M1_G1" NUMBER(*,0) DEFAULT 0, 
	"J_ID_M1_G2" NUMBER(*,0), 
	"NOM_M1_G2" VARCHAR2(75 CHAR), 
	"MVP_M1_G2" NUMBER(*,0) DEFAULT 0, 
	"J_ID_M2_G1" NUMBER(*,0), 
	"NOM_M2_G1" VARCHAR2(75 CHAR), 
	"MVP_M2_G1" NUMBER(*,0) DEFAULT 0, 
	"J_ID_M2_G2" NUMBER(*,0), 
	"NOM_M2_G2" VARCHAR2(75 CHAR), 
	"MVP_M2_G2" NUMBER(*,0) DEFAULT 0
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."J_ID_M1_G1" IS 'Identificador del jugador per a la modalitat normal i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."NOM_M1_G1" IS 'Nom del jugador per a la modalitat normal i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."MVP_M1_G1" IS 'Mitjana de valoracions ponderades del jugador per a la modalitat normal i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."J_ID_M1_G2" IS 'Identificador del jugador per a la modalitat normal i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."NOM_M1_G2" IS 'Nom del jugador per a la modalitat normal i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."MVP_M1_G2" IS 'Mitjana de valoracions ponderades del jugador per a la modalitat normal i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."J_ID_M2_G1" IS 'Identificador del jugador per a la modalitat Cadira de rodes i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."NOM_M2_G1" IS 'Nom del jugador per a la modalitat Cadira de rodes i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."MVP_M2_G1" IS 'Mitjana de valoracions ponderades del jugador per a la modalitat cadira de rodes i gnere mascul.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."J_ID_M2_G2" IS 'Identificador del jugador per a la modalitat Cadira de rodes i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."NOM_M2_G2" IS 'Nom del jugador per a la modalitat Cadira de rodes i gnere femen.';
   COMMENT ON COLUMN "SYSTEM"."M_E_C7"."MVP_M2_G2" IS 'Mitjana de valoracions ponderades del jugador per a la modalitat cadira de rodes i gnere femen.';
--------------------------------------------------------
--  DDL for Table MODALITAT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."MODALITAT" 
   (	"MODALITAT_ID" NUMBER(*,0), 
	"MODALITAT" VARCHAR2(15 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."MODALITAT"."MODALITAT_ID" IS 'Identificador de la modalitat.';
   COMMENT ON COLUMN "SYSTEM"."MODALITAT"."MODALITAT" IS '1 Normal, 2 Cadira de rodes.';
--------------------------------------------------------
--  DDL for Table PAIS
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."PAIS" 
   (	"PAIS_ID" NUMBER(*,0), 
	"PAIS" VARCHAR2(41 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."PAIS"."PAIS_ID" IS 'Identificador del pas.';
   COMMENT ON COLUMN "SYSTEM"."PAIS"."PAIS" IS 'Nom del pas.';
--------------------------------------------------------
--  DDL for Table PARTIT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."PARTIT" 
   (	"PARTIT_ID" NUMBER(*,0), 
	"DATA_HORA" DATE, 
	"MUNICIPI" VARCHAR2(40 CHAR), 
	"PAVELLO" VARCHAR2(24 CHAR), 
	"EQUIP_LOCAL_ID" NUMBER(*,0), 
	"EQUIP_VISITANT_ID" NUMBER(*,0), 
	"COMPETICIO_ID" NUMBER(*,0), 
	"ARBITRE_P_ID" NUMBER(*,0), 
	"L1_ID" NUMBER(*,0), 
	"L2_ID" NUMBER(*,0), 
	"L3_ID" NUMBER(*,0), 
	"L4_ID" NUMBER(*,0), 
	"L5_ID" NUMBER(*,0), 
	"L6_ID" NUMBER(*,0), 
	"L7_ID" NUMBER(*,0), 
	"L8_ID" NUMBER(*,0), 
	"L9_ID" NUMBER(*,0), 
	"L10_ID" NUMBER(*,0), 
	"L11_ID" NUMBER(*,0), 
	"L12_ID" NUMBER(*,0), 
	"V1_ID" NUMBER(*,0), 
	"V2_ID" NUMBER(*,0), 
	"V3_ID" NUMBER(*,0), 
	"V4_ID" NUMBER(*,0), 
	"V5_ID" NUMBER(*,0), 
	"V6_ID" NUMBER(*,0), 
	"V7_ID" NUMBER(*,0), 
	"V8_ID" NUMBER(*,0), 
	"V9_ID" NUMBER(*,0), 
	"V10_ID" NUMBER(*,0), 
	"V11_ID" NUMBER(*,0), 
	"V12_ID" NUMBER(*,0), 
	"ARBITRE_AUX1_ID" NUMBER(*,0), 
	"ARBITRE_AUX2_ID" NUMBER(*,0), 
	"ARBITRE_AUX3_ID" NUMBER(*,0)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."PARTIT"."PARTIT_ID" IS 'Identificador del partit.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."DATA_HORA" IS 'Data i hora del partit.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."MUNICIPI" IS 'Municipi a on es juga el partit.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."PAVELLO" IS 'Pavell a on es juga el partit.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."EQUIP_LOCAL_ID" IS 'Identificador de l''equip local.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."EQUIP_VISITANT_ID" IS 'Identificador de l''equip visitant.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."COMPETICIO_ID" IS 'Identificador de la competici.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."ARBITRE_P_ID" IS 'Identificador de l''rbitre principal.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."ARBITRE_AUX1_ID" IS 'Identificador del primer rbitre auxiliar.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."ARBITRE_AUX2_ID" IS 'Identificador del segon rbitre auxiliar.';
   COMMENT ON COLUMN "SYSTEM"."PARTIT"."ARBITRE_AUX3_ID" IS 'Identificador del tercer rbitre auxiliar. (Noms a competicions continentals).';
--------------------------------------------------------
--  DDL for Table POSICIO
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."POSICIO" 
   (	"POSICIO_ID" NUMBER(*,0), 
	"POSICIO" VARCHAR2(10 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."POSICIO"."POSICIO_ID" IS 'Identificador de posici.';
   COMMENT ON COLUMN "SYSTEM"."POSICIO"."POSICIO" IS 'Posici on juga habitualment. 1: base, 2: escorta, 3: aler, 4: aler-pivot, 5: pivot';
--------------------------------------------------------
--  DDL for Table REPRESENTANT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."REPRESENTANT" 
   (	"REPRESENTANT_ID" NUMBER(*,0), 
	"REPRESENTANT" VARCHAR2(40 CHAR), 
	"EMPRESA" VARCHAR2(40 CHAR), 
	"DIRECCIO" VARCHAR2(250 CHAR), 
	"E_MAIL" VARCHAR2(50 CHAR), 
	"TELEFON" VARCHAR2(26 CHAR), 
	"MOBIL" VARCHAR2(26 CHAR), 
	"FAX" VARCHAR2(26 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."REPRESENTANT_ID" IS 'Identificador del representant.';
   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."REPRESENTANT" IS 'Nom del representant.';
   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."EMPRESA" IS 'Empresa del representant.';
   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."DIRECCIO" IS 'Direcci del representant (empresa).';
   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."E_MAIL" IS 'E-mail del representant.';
   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."TELEFON" IS 'Telfon del representant.';
   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."MOBIL" IS 'Telfon mbil del representant.';
   COMMENT ON COLUMN "SYSTEM"."REPRESENTANT"."FAX" IS 'FAX del representant.';
--------------------------------------------------------
--  DDL for Table SUB_ESTAT
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."SUB_ESTAT" 
   (	"SUB_ESTAT_ID" NUMBER(*,0), 
	"SUB_ESTAT" VARCHAR2(26 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."SUB_ESTAT"."SUB_ESTAT_ID" IS 'Identificador del sub-estat.';
   COMMENT ON COLUMN "SYSTEM"."SUB_ESTAT"."SUB_ESTAT" IS 'Sub-estat. 0: Sense subestat, 1: Baixa mdica, 2: Baixa per motius personals.';
--------------------------------------------------------
--  DDL for Table TABLE1
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."TABLE1" 
   (	"COLUMN1" VARCHAR2(20 BYTE)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;
--------------------------------------------------------
--  DDL for Table TEMPORADA
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."TEMPORADA" 
   (	"TEMPORADA_ID" NUMBER(*,0), 
	"TEMPORADA" VARCHAR2(20 CHAR), 
	"TEMPORADA_ACTUAL" NUMBER(*,0) DEFAULT 0, 
	"ANTERIOR_ID" NUMBER(*,0) DEFAULT 0
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."TEMPORADA"."TEMPORADA_ID" IS 'Identificador de temporada.';
   COMMENT ON COLUMN "SYSTEM"."TEMPORADA"."TEMPORADA" IS 'Temporada de la competici.';
   COMMENT ON COLUMN "SYSTEM"."TEMPORADA"."TEMPORADA_ACTUAL" IS 'Indica si aquesta temporada s l''''actual. 0: No, 1: S.';
   COMMENT ON COLUMN "SYSTEM"."TEMPORADA"."ANTERIOR_ID" IS 'Temporada que ja no s l''actual. Permet anar cap enrere en les temporades.';
--------------------------------------------------------
--  DDL for Table TIPUS_EQUIP
--------------------------------------------------------

  CREATE TABLE "SYSTEM"."TIPUS_EQUIP" 
   (	"TIPUS_EQUIP_ID" NUMBER(*,0), 
	"TIPUS_EQUIP" VARCHAR2(4 CHAR)
   ) PCTFREE 10 PCTUSED 40 INITRANS 1 MAXTRANS 255 NOCOMPRESS LOGGING
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM" ;

   COMMENT ON COLUMN "SYSTEM"."TIPUS_EQUIP"."TIPUS_EQUIP_ID" IS 'Identificador del tipus d''equip.';
   COMMENT ON COLUMN "SYSTEM"."TIPUS_EQUIP"."TIPUS_EQUIP" IS 'Indicador de si s un club o una societat (annima, limitada, etc.). 1: Club, 2: S.A. 3:S.L.';
--------------------------------------------------------
--  Constraints for Table ACTIVITAT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."ACTIVITAT" ADD CONSTRAINT "ACTIVITAT_UK" UNIQUE ("ACTIVITAT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ACTIVITAT" ADD CONSTRAINT "ACTIVITAT_PK" PRIMARY KEY ("ACTIVITAT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ACTIVITAT" MODIFY ("ACTIVITAT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ACTIVITAT" MODIFY ("ACTIVITAT_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table AMBIT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."AMBIT" ADD CONSTRAINT "AMBIT_UK" UNIQUE ("AMBIT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."AMBIT" ADD CONSTRAINT "AMBIT_PK" PRIMARY KEY ("AMBIT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."AMBIT" MODIFY ("AMBIT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."AMBIT" MODIFY ("AMBIT_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table ARBITRE
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."ARBITRE" ADD CONSTRAINT "ARBITRE_UK" UNIQUE ("ARBITRE")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ARBITRE" ADD CONSTRAINT "ARBITRE_PK" PRIMARY KEY ("ARBITRE_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ARBITRE" MODIFY ("ARBITRE" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ARBITRE" MODIFY ("ARBITRE_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table CATEGORIA
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."CATEGORIA" ADD CONSTRAINT "CATEGORIA_UK" UNIQUE ("CATEGORIA")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."CATEGORIA" ADD CONSTRAINT "CATEGORIA_PK" PRIMARY KEY ("CATEGORIA_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."CATEGORIA" MODIFY ("CATEGORIA" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CATEGORIA" MODIFY ("CATEGORIA_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table COMPETICIO
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_CATEG_FACTOR_P_CHK" CHECK ((CATEGORIA_ID = 1 AND FACTOR_P = 10) OR (CATEGORIA_ID = 2 AND FACTOR_P = 8)) ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_UK" UNIQUE ("COMPETICIO")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_TEMPORADA_UK" UNIQUE ("COMPETICIO_ID", "TEMPORADA_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_PAIS_CONTINENT_CHK" CHECK (PAIS_ID != null OR CONTINENT_ID != null) ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_AMBIT_N_ARB_CHK" CHECK ((AMBIT_ID = 1 AND N_ARBITRES = 3) OR (AMBIT_ID = 2 AND N_ARBITRES = 4)) ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_PK" PRIMARY KEY ("COMPETICIO_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("FACTOR_P" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("CATEGORIA_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("N_ARBITRES" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("MODALITAT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("GENERE_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("AMBIT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("COMPETICIO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."COMPETICIO" MODIFY ("COMPETICIO_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table CONTINENT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."CONTINENT" ADD CONSTRAINT "CONTINENT_UK" UNIQUE ("CONTINENT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."CONTINENT" ADD CONSTRAINT "CONTINENT_PK" PRIMARY KEY ("CONTINENT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."CONTINENT" MODIFY ("CONTINENT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTINENT" MODIFY ("CONTINENT" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table CONTRACTE
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("PRIMERA_TEMPORADA_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("ULTIM" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_DATAFI_DATAINI_CHK" CHECK (DATA_SIGNATURA < DATA_FINAL_CONTRACTE) ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("DATA_FINAL_CONTRACTE" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("REPRESENTANT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_PK" PRIMARY KEY ("CONTRACTE_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("VALOR_OPERACIO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("COMPENSACIO_A_EQUIP_VENEDOR" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("SALARI_BRUT_ANUAL" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("DURADA_CONTRACTE" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("EQUIP_VENEDOR_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("EQUIP_COMPRADOR_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("JUGADOR_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("DATA_SIGNATURA" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" MODIFY ("CONTRACTE_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_DATA_JUG_EQ_UK" UNIQUE ("DATA_SIGNATURA", "JUGADOR_ID", "EQUIP_COMPRADOR_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
--------------------------------------------------------
--  Constraints for Table CONTRACTE_TEMPORADA
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."CONTRACTE_TEMPORADA" ADD CONSTRAINT "CONTRACTE_TEMPORADA_UK1" UNIQUE ("CONTRACTE_ID", "TEMPORADA_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE_TEMPORADA" ADD CONSTRAINT "CONTRACTE_TEMPORADA_PK" PRIMARY KEY ("C_T_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE_TEMPORADA" MODIFY ("TEMPORADA_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE_TEMPORADA" MODIFY ("CONTRACTE_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."CONTRACTE_TEMPORADA" MODIFY ("C_T_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table EQUIP
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("GENERE_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" ADD CONSTRAINT "EQUIP_PK" PRIMARY KEY ("EQUIP_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("PAVELLO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" ADD CONSTRAINT "EQUIP_UK" UNIQUE ("EQUIP")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("ENTRENADOR_AJUDANT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("PRIMER_ENTRENADOR" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("TIPUS_EQUIP_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("ADREA" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("PAIS_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("MUNICIPI_PAVELLO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("REPRESENTANT_LEGAL" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("EQUIP" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."EQUIP" MODIFY ("EQUIP_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table ESTADISTIQUES_P_J
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("VP" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" ADD CONSTRAINT "ESTADISTIQUES_PARTIT_JUGA_UK" UNIQUE ("PARTIT_ID", "JUGADOR_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" ADD CONSTRAINT "ESTADISTIQUES_PARTIT_JUGA_PK" PRIMARY KEY ("ESTADISTICA_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("V" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("FR" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("FC" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("PP" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("PR" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("TC" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("TF" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("ASS" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("RO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("RD" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("T3E" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("T3I" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("T2E" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("T2I" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("T1E" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("T1I" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("PT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("MINUTS_JUGATS" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("JUGADOR_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("PARTIT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" MODIFY ("ESTADISTICA_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table ESTAT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."ESTAT" ADD CONSTRAINT "ESTAT_UK" UNIQUE ("ESTAT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ESTAT" ADD CONSTRAINT "ESTAT_PK" PRIMARY KEY ("ESTAT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."ESTAT" MODIFY ("ESTAT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."ESTAT" MODIFY ("ESTAT_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table GENERE
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."GENERE" ADD CONSTRAINT "GENERE_UK" UNIQUE ("GENERE")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."GENERE" ADD CONSTRAINT "GENERE_PK" PRIMARY KEY ("GENERE_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."GENERE" MODIFY ("GENERE_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table JUGADOR
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "FEDERACIO_ID_FED_NUMERO_FED_UK" UNIQUE ("FEDERACIO_ID", "NUMERO_FEDERAT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("MODALITAT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("GENERE_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("REPRESENTANT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("SUB_ESTAT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("ESTAT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("ACTIVITAT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("POSICIO_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("PES" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("ALADA" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("DATA_NAIXEMENT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("NOM" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("NUMERO_FEDERAT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("FEDERACIO_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_PK" PRIMARY KEY ("JUGADOR_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("NACIONALITAT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."JUGADOR" MODIFY ("JUGADOR_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table LOG_CRIDES
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."LOG_CRIDES" MODIFY ("LOG_CRIDES_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."LOG_CRIDES" MODIFY ("PROCEDIMENT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."LOG_CRIDES" ADD CONSTRAINT "LOG_CRIDES_PK" PRIMARY KEY ("LOG_CRIDES_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."LOG_CRIDES" MODIFY ("RSP" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."LOG_CRIDES" MODIFY ("INICI" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."LOG_CRIDES" MODIFY ("FI" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table M_E_C1
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."M_E_C1" MODIFY ("JUGADORS_ACTIUS" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table M_E_C2
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."M_E_C2" MODIFY ("PUNTS" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C2" MODIFY ("JUGADOR" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C2" MODIFY ("JUGADOR_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C2" MODIFY ("COMPETICIO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C2" MODIFY ("COMPETICIO_ID" NOT NULL ENABLE);

--------------------------------------------------------
--  Constraints for Table M_E_C4
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."M_E_C4" MODIFY ("JUGADOR_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table M_E_C5
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."M_E_C5" MODIFY ("SOU_MIG_ANUAL" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C5" MODIFY ("TEMPORADA_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C5" MODIFY ("MODALITAT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C5" MODIFY ("PAIS_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C5" MODIFY ("GENERE_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table M_E_C6
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."M_E_C6" MODIFY ("MILLOR_DEFENSIU_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C6" MODIFY ("TEMPORADA_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C6" MODIFY ("COMPETICIO_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C6" MODIFY ("MILLOR_OFENSIU_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table M_E_C7
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("MVP_M2_G2" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("J_ID_M2_G2" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("MVP_M2_G1" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("J_ID_M2_G1" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("MVP_M1_G2" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("J_ID_M1_G2" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("MVP_M1_G1" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."M_E_C7" MODIFY ("J_ID_M1_G1" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table MODALITAT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."MODALITAT" ADD CONSTRAINT "MODALITAT_UK" UNIQUE ("MODALITAT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."MODALITAT" ADD CONSTRAINT "MODALITAT_PK" PRIMARY KEY ("MODALITAT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."MODALITAT" MODIFY ("MODALITAT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."MODALITAT" MODIFY ("MODALITAT_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table PAIS
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."PAIS" ADD CONSTRAINT "PAIS_UK" UNIQUE ("PAIS")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."PAIS" ADD CONSTRAINT "PAIS_PK" PRIMARY KEY ("PAIS_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."PAIS" MODIFY ("PAIS" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PAIS" MODIFY ("PAIS_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table PARTIT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("ARBITRE_AUX2_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("ARBITRE_AUX1_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V12_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V11_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V10_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V9_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V8_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V7_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L9_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L8_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L7_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L6_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L5_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L4_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L3_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L2_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L1_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "CONVOCATS_VISITA_DIFERENTS_CHK" CHECK (V1_ID != V2_ID AND V1_ID != V3_ID AND V1_ID != V4_ID AND V1_ID != V5_ID AND V1_ID != V6_ID AND V1_ID != V7_ID AND V1_ID != V8_ID AND V1_ID != V9_ID AND V1_ID != V10_ID AND V1_ID != V11_ID AND V1_ID != V12_ID AND V2_ID != V3_ID AND V2_ID != V4_ID AND V2_ID != V5_ID AND V2_ID != V6_ID AND V2_ID != V7_ID AND V2_ID != V8_ID AND V2_ID != V9_ID AND V2_ID != V10_ID AND V2_ID != V11_ID AND V2_ID != V12_ID AND V3_ID != V4_ID AND V3_ID != V5_ID AND V3_ID != V6_ID AND V3_ID != V7_ID AND V3_ID != V8_ID AND V3_ID != V9_ID AND V3_ID != V10_ID AND V3_ID != V11_ID AND V3_ID != V12_ID AND V4_ID != V5_ID AND V4_ID != V6_ID AND V4_ID != V7_ID AND V4_ID != V8_ID AND V4_ID != V9_ID AND V4_ID != V10_ID AND V4_ID != V11_ID AND V4_ID != V12_ID AND V5_ID != V6_ID AND V5_ID != V7_ID AND V5_ID != V8_ID AND V5_ID != V9_ID AND V5_ID != V10_ID AND V5_ID != V11_ID AND V5_ID != V12_ID AND V6_ID != V7_ID AND V6_ID != V8_ID AND V6_ID != V9_ID AND V6_ID != V10_ID AND V6_ID != V11_ID AND V6_ID != V12_ID AND V7_ID != V8_ID AND V7_ID != V9_ID AND V7_ID != V10_ID AND V7_ID != V11_ID AND V7_ID != V12_ID AND V8_ID != V9_ID AND V8_ID != V10_ID AND V8_ID != V11_ID AND V8_ID != V12_ID AND V9_ID != V10_ID AND V9_ID != V11_ID AND V9_ID != V12_ID AND V10_ID != V11_ID AND V10_ID != V12_ID AND V11_ID != V12_ID) ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "CONVOCATS_LOCALS_DIFERENTS_CHK" CHECK (L1_ID != L2_ID AND L1_ID != L3_ID AND L1_ID != L4_ID AND L1_ID != L5_ID AND L1_ID != L6_ID AND L1_ID != L7_ID AND L1_ID != L8_ID AND L1_ID != L9_ID AND L1_ID != L10_ID AND L1_ID != L11_ID AND L1_ID != L12_ID AND L2_ID != L3_ID AND L2_ID != L4_ID AND L2_ID != L5_ID AND L2_ID != L6_ID AND L2_ID != L7_ID AND L2_ID != L8_ID AND L2_ID != L9_ID AND L2_ID != L10_ID AND L2_ID != L11_ID AND L2_ID != L12_ID AND L3_ID != L4_ID AND L3_ID != L5_ID AND L3_ID != L6_ID AND L3_ID != L7_ID AND L3_ID != L8_ID AND L3_ID != L9_ID AND L3_ID != L10_ID AND L3_ID != L11_ID AND L3_ID != L12_ID AND L4_ID != L5_ID AND L4_ID != L6_ID AND L4_ID != L7_ID AND L4_ID != L8_ID AND L4_ID != L9_ID AND L4_ID != L10_ID AND L4_ID != L11_ID AND L4_ID != L12_ID AND L5_ID != L6_ID AND L5_ID != L7_ID AND L5_ID != L8_ID AND L5_ID != L9_ID AND L5_ID != L10_ID AND L5_ID != L11_ID AND L5_ID != L12_ID AND L6_ID != L7_ID AND L6_ID != L8_ID AND L6_ID != L9_ID AND L6_ID != L10_ID AND L6_ID != L11_ID AND L6_ID != L12_ID AND L7_ID != L8_ID AND L7_ID != L9_ID AND L7_ID != L10_ID AND L7_ID != L11_ID AND L7_ID != L12_ID AND L8_ID != L9_ID AND L8_ID != L10_ID AND L8_ID != L11_ID AND L8_ID != L12_ID AND L9_ID != L10_ID AND L9_ID != L11_ID AND L9_ID != L12_ID AND L10_ID != L11_ID AND L10_ID != L12_ID AND L11_ID != L12_ID) ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("ARBITRE_P_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("COMPETICIO_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("EQUIP_VISITANT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("EQUIP_LOCAL_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("PAVELLO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V6_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("MUNICIPI" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_PK" PRIMARY KEY ("PARTIT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("DATA_HORA" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("PARTIT_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V5_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V4_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V3_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V2_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("V1_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L12_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L11_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" MODIFY ("L10_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_ARBITRES_DIFERENTS_CHK" CHECK (ARBITRE_P_ID != ARBITRE_AUX1_ID AND ARBITRE_P_ID != ARBITRE_AUX2_ID AND ARBITRE_P_ID != ARBITRE_AUX3_ID AND ARBITRE_AUX1_ID != ARBITRE_AUX2_ID AND ARBITRE_AUX1_ID != ARBITRE_AUX3_ID AND ARBITRE_AUX2_ID != ARBITRE_AUX3_ID) ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_DATA_HORA_UK" UNIQUE ("DATA_HORA", "MUNICIPI", "PAVELLO")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
--------------------------------------------------------
--  Constraints for Table POSICIO
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."POSICIO" ADD CONSTRAINT "POSICIO_UK" UNIQUE ("POSICIO")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."POSICIO" ADD CONSTRAINT "POSICIO_PK" PRIMARY KEY ("POSICIO_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."POSICIO" MODIFY ("POSICIO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."POSICIO" MODIFY ("POSICIO_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table REPRESENTANT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."REPRESENTANT" ADD CONSTRAINT "REPRESENTANT_UK" UNIQUE ("REPRESENTANT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."REPRESENTANT" ADD CONSTRAINT "REPRESENTANT_PK" PRIMARY KEY ("REPRESENTANT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."REPRESENTANT" MODIFY ("TELEFON" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."REPRESENTANT" MODIFY ("E_MAIL" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."REPRESENTANT" MODIFY ("DIRECCIO" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."REPRESENTANT" MODIFY ("REPRESENTANT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."REPRESENTANT" MODIFY ("REPRESENTANT_ID" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table SUB_ESTAT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."SUB_ESTAT" ADD CONSTRAINT "SUB_ESTAT_UK" UNIQUE ("SUB_ESTAT")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."SUB_ESTAT" ADD CONSTRAINT "SUB_ESTAT_PK" PRIMARY KEY ("SUB_ESTAT_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."SUB_ESTAT" MODIFY ("SUB_ESTAT" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."SUB_ESTAT" MODIFY ("SUB_ESTAT_ID" NOT NULL ENABLE);

--------------------------------------------------------
--  Constraints for Table TEMPORADA
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."TEMPORADA" MODIFY ("ANTERIOR_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."TEMPORADA" ADD CONSTRAINT "TEMPORADA_UK" UNIQUE ("TEMPORADA")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."TEMPORADA" ADD CONSTRAINT "TEMPORADA_PK" PRIMARY KEY ("TEMPORADA_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."TEMPORADA" MODIFY ("TEMPORADA_ID" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."TEMPORADA" MODIFY ("TEMPORADA" NOT NULL ENABLE);
--------------------------------------------------------
--  Constraints for Table TIPUS_EQUIP
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."TIPUS_EQUIP" ADD CONSTRAINT "TIPUS_EQUIP_UK" UNIQUE ("TIPUS_EQUIP")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."TIPUS_EQUIP" ADD CONSTRAINT "TIPUS_EQUIP_PK" PRIMARY KEY ("TIPUS_EQUIP_ID")
  USING INDEX PCTFREE 10 INITRANS 2 MAXTRANS 255 COMPUTE STATISTICS 
  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645
  PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT)
  TABLESPACE "SYSTEM"  ENABLE;
  ALTER TABLE "SYSTEM"."TIPUS_EQUIP" MODIFY ("TIPUS_EQUIP" NOT NULL ENABLE);
  ALTER TABLE "SYSTEM"."TIPUS_EQUIP" MODIFY ("TIPUS_EQUIP_ID" NOT NULL ENABLE);




--------------------------------------------------------
--  Ref Constraints for Table COMPETICIO
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_AMBIT_FK" FOREIGN KEY ("AMBIT_ID")
	  REFERENCES "SYSTEM"."AMBIT" ("AMBIT_ID") ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_CATEGORIA_FK" FOREIGN KEY ("CATEGORIA_ID")
	  REFERENCES "SYSTEM"."CATEGORIA" ("CATEGORIA_ID") ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_CONTINENT_FK" FOREIGN KEY ("CONTINENT_ID")
	  REFERENCES "SYSTEM"."CONTINENT" ("CONTINENT_ID") ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_GENERE_FK" FOREIGN KEY ("GENERE_ID")
	  REFERENCES "SYSTEM"."GENERE" ("GENERE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_MODALITAT_FK" FOREIGN KEY ("MODALITAT_ID")
	  REFERENCES "SYSTEM"."MODALITAT" ("MODALITAT_ID") ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_PAIS_FK" FOREIGN KEY ("PAIS_ID")
	  REFERENCES "SYSTEM"."PAIS" ("PAIS_ID") ENABLE;
  ALTER TABLE "SYSTEM"."COMPETICIO" ADD CONSTRAINT "COMPETICIO_TEMPORADA_FK" FOREIGN KEY ("TEMPORADA_ID")
	  REFERENCES "SYSTEM"."TEMPORADA" ("TEMPORADA_ID") ENABLE;

--------------------------------------------------------
--  Ref Constraints for Table CONTRACTE
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_EQUIP_COMPRADOR_FK" FOREIGN KEY ("EQUIP_COMPRADOR_ID")
	  REFERENCES "SYSTEM"."EQUIP" ("EQUIP_ID") ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_EQUIP_VENEDOR_FK" FOREIGN KEY ("EQUIP_VENEDOR_ID")
	  REFERENCES "SYSTEM"."EQUIP" ("EQUIP_ID") ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_JUGADOR_FK" FOREIGN KEY ("JUGADOR_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_PRIMERA_TEMPORADA_FK" FOREIGN KEY ("PRIMERA_TEMPORADA_ID")
	  REFERENCES "SYSTEM"."TEMPORADA" ("TEMPORADA_ID") ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE" ADD CONSTRAINT "CONTRACTE_REPRESENTANT_FK" FOREIGN KEY ("REPRESENTANT_ID")
	  REFERENCES "SYSTEM"."REPRESENTANT" ("REPRESENTANT_ID") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table CONTRACTE_TEMPORADA
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."CONTRACTE_TEMPORADA" ADD CONSTRAINT "CONTRACTE_TEMPORADA_C_FK" FOREIGN KEY ("CONTRACTE_ID")
	  REFERENCES "SYSTEM"."CONTRACTE" ("CONTRACTE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."CONTRACTE_TEMPORADA" ADD CONSTRAINT "CONTRACTE_TEMPORADA_T_FK" FOREIGN KEY ("TEMPORADA_ID")
	  REFERENCES "SYSTEM"."TEMPORADA" ("TEMPORADA_ID") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table EQUIP
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."EQUIP" ADD CONSTRAINT "EQUIP_GENERE_FK" FOREIGN KEY ("GENERE_ID")
	  REFERENCES "SYSTEM"."GENERE" ("GENERE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."EQUIP" ADD CONSTRAINT "EQUIP_PAIS_FK" FOREIGN KEY ("PAIS_ID")
	  REFERENCES "SYSTEM"."PAIS" ("PAIS_ID") ENABLE;
  ALTER TABLE "SYSTEM"."EQUIP" ADD CONSTRAINT "EQUIP_TIPUS_EQUIP_FK" FOREIGN KEY ("TIPUS_EQUIP_ID")
	  REFERENCES "SYSTEM"."TIPUS_EQUIP" ("TIPUS_EQUIP_ID") ENABLE;
--------------------------------------------------------
--  Ref Constraints for Table ESTADISTIQUES_P_J
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" ADD CONSTRAINT "ESTADISTIQUES_P_J_JUG_ID_FK" FOREIGN KEY ("JUGADOR_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."ESTADISTIQUES_P_J" ADD CONSTRAINT "ESTADISTIQUES_P_J_PARTIT_ID_FK" FOREIGN KEY ("PARTIT_ID")
	  REFERENCES "SYSTEM"."PARTIT" ("PARTIT_ID") ENABLE;


--------------------------------------------------------
--  Ref Constraints for Table JUGADOR
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_ACTIVITAT_FK" FOREIGN KEY ("ACTIVITAT_ID")
	  REFERENCES "SYSTEM"."ACTIVITAT" ("ACTIVITAT_ID") ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_ESTAT_FK" FOREIGN KEY ("ESTAT_ID")
	  REFERENCES "SYSTEM"."ESTAT" ("ESTAT_ID") ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_FEDERACIO_PAIS_FK" FOREIGN KEY ("FEDERACIO_ID")
	  REFERENCES "SYSTEM"."PAIS" ("PAIS_ID") ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_GENERE_FK" FOREIGN KEY ("GENERE_ID")
	  REFERENCES "SYSTEM"."GENERE" ("GENERE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_NACIONALITAT_FK" FOREIGN KEY ("NACIONALITAT_ID")
	  REFERENCES "SYSTEM"."PAIS" ("PAIS_ID") ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_POSICIO_FK" FOREIGN KEY ("POSICIO_ID")
	  REFERENCES "SYSTEM"."POSICIO" ("POSICIO_ID") ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_REPRESENTANT_FK" FOREIGN KEY ("REPRESENTANT_ID")
	  REFERENCES "SYSTEM"."REPRESENTANT" ("REPRESENTANT_ID") ENABLE;
  ALTER TABLE "SYSTEM"."JUGADOR" ADD CONSTRAINT "JUGADOR_SUB_ESTAT_FK" FOREIGN KEY ("SUB_ESTAT_ID")
	  REFERENCES "SYSTEM"."SUB_ESTAT" ("SUB_ESTAT_ID") ENABLE;










--------------------------------------------------------
--  Ref Constraints for Table PARTIT
--------------------------------------------------------

  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_ARBITRE_AUX1_FK" FOREIGN KEY ("ARBITRE_AUX1_ID")
	  REFERENCES "SYSTEM"."ARBITRE" ("ARBITRE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_ARBITRE_AUX2_FK" FOREIGN KEY ("ARBITRE_AUX2_ID")
	  REFERENCES "SYSTEM"."ARBITRE" ("ARBITRE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_ARBITRE_AUX3_FK" FOREIGN KEY ("ARBITRE_AUX3_ID")
	  REFERENCES "SYSTEM"."ARBITRE" ("ARBITRE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_ARBITRE_P_FK" FOREIGN KEY ("ARBITRE_P_ID")
	  REFERENCES "SYSTEM"."ARBITRE" ("ARBITRE_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_COMPETICIO_FK" FOREIGN KEY ("COMPETICIO_ID")
	  REFERENCES "SYSTEM"."COMPETICIO" ("COMPETICIO_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_EQUIP_LOCAL_FK" FOREIGN KEY ("EQUIP_LOCAL_ID")
	  REFERENCES "SYSTEM"."EQUIP" ("EQUIP_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_EQUIP_VISITANT_FK" FOREIGN KEY ("EQUIP_VISITANT_ID")
	  REFERENCES "SYSTEM"."EQUIP" ("EQUIP_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L10_FK" FOREIGN KEY ("L10_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L11_FK" FOREIGN KEY ("L11_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L12_FK" FOREIGN KEY ("L12_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L1_FK" FOREIGN KEY ("L1_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L2_FK" FOREIGN KEY ("L2_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L3_FK" FOREIGN KEY ("L3_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L4_FK" FOREIGN KEY ("L4_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L5_FK" FOREIGN KEY ("L5_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L6_FK" FOREIGN KEY ("L6_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L7_FK" FOREIGN KEY ("L7_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L8_FK" FOREIGN KEY ("L8_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_L9_FK" FOREIGN KEY ("L9_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V10_FK" FOREIGN KEY ("V10_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V11_FK" FOREIGN KEY ("V11_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V12_FK" FOREIGN KEY ("V12_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V1_FK" FOREIGN KEY ("V1_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V2_FK" FOREIGN KEY ("V2_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V3_FK" FOREIGN KEY ("V3_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V4_FK" FOREIGN KEY ("V4_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V5_FK" FOREIGN KEY ("V5_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V6_FK" FOREIGN KEY ("V6_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V7_FK" FOREIGN KEY ("V7_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V8_FK" FOREIGN KEY ("V8_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;
  ALTER TABLE "SYSTEM"."PARTIT" ADD CONSTRAINT "PARTIT_V9_FK" FOREIGN KEY ("V9_ID")
	  REFERENCES "SYSTEM"."JUGADOR" ("JUGADOR_ID") ENABLE;






--------------------------------------------------------
--  DDL for Trigger TGR_ACTUALITZA_M_E_C1_0
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_ACTUALITZA_M_E_C1_0" 
-- AFTER INSERT OR UPDATE OF ESTAT_ID ON jugador
AFTER INSERT OR UPDATE ON table1
begin
  modul_estadistic.actualitza_M_E_C1();
END;
/
ALTER TRIGGER "SYSTEM"."TGR_ACTUALITZA_M_E_C1_0" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_COMPETICIO_0
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_COMPETICIO_0" 
-- AFTER INSERT OR UPDATE ON COMPETICIO 
AFTER INSERT OR UPDATE ON table1
FOR EACH ROW 
DECLARE
  temp temporada.temporada_id%type;
begin
  select temporada_id into temp from competicio where competicio_id = :old.competicio_id;
  modul_estadistic.actualitza_m_e_c2(:old.competicio_id);
  if (:old.temporada_id != null) then modul_estadistic.actualitza_M_E_C6(:old.competicio_id, :new.temporada_id); end if;
  modul_estadistic.actualitza_M_E_C7();
END;
/
ALTER TRIGGER "SYSTEM"."TGR_COMPETICIO_0" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_CONTRACTE_ULTIM
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_CONTRACTE_ULTIM" 
BEFORE INSERT ON CONTRACTE 
FOR EACH ROW 
BEGIN
 -- El contracte deixa de ser l'ltim quan s'introdueix un altre amb el mateix jugador que un contracte anterior amb el camp actual = 1
  update contracte set ultim = 0 where jugador_id = :new.jugador_id and ultim = 1;
END;
/
ALTER TRIGGER "SYSTEM"."TGR_CONTRACTE_ULTIM" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_CONTRACTE_0
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_CONTRACTE_0" 
-- AFTER INSERT OR UPDATE ON CONTRACTE 
AFTER INSERT OR UPDATE ON table1
BEGIN
  modul_estadistic.actualitza_M_E_C3();
  modul_estadistic.actualitza_M_E_C4();
END;
/
ALTER TRIGGER "SYSTEM"."TGR_CONTRACTE_0" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_ESTADISTIQUES_P_J
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_ESTADISTIQUES_P_J" 
-- AFTER INSERT OR UPDATE ON ESTADISTIQUES_P_J 
AFTER INSERT OR UPDATE ON ESTADISTIQUES_P_J 
FOR EACH ROW
DECLARE
  comp competicio.competicio_id%type;
  temp temporada.temporada_id%type;
begin
  /*Select p.competicio_id Into comp From partit p Where p.partit_id = :old.partit_id;
  Select temporada_id Into temp From competicio Where competicio_id = comp;
  modul_estadistic.actualitza_M_E_C2(comp);
  modul_estadistic.actualitza_m_e_c6(comp, temp);
  modul_estadistic.actualitza_m_e_c7();*/
  null;
END;
/
ALTER TRIGGER "SYSTEM"."TGR_ESTADISTIQUES_P_J" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_JUGADOR_0
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_JUGADOR_0" 
-- AFTER INSERT OR UPDATE ON JUGADOR 
AFTER INSERT OR UPDATE ON table1
FOR EACH ROW
DECLARE
temp TEMPORADA.TEMPORADA_ID%type;
begin
  /*modul_estadistic.actualitza_M_E_C1();
  modul_estadistic.actualitza_m_e_c3();
  modul_estadistic.actualitza_M_E_C4();*/
  select ct.temporada_id into temp from jugador j, contracte c, contracte_temporada ct, temporada t where 
    c.jugador_id = :old.jugador_id 
    And c.ultim = 1
    and c.contracte_id = ct.contracte_id;
  /*modul_estadistic.actualitza_m_e_c5(:new.federacio_id, temp, :new.genere_id, :new.modalitat_id);
  modul_estadistic.actualitza_M_E_C7();*/
  modul_estadistic.taula_jugador_canviada(temp, :old.federacio_id, :old.genere_id, :old.modalitat_id);
END;
/
ALTER TRIGGER "SYSTEM"."TGR_JUGADOR_0" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_PARTIT_0
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_PARTIT_0" 
-- AFTER INSERT OR UPDATE ON PARTIT 
AFTER INSERT OR UPDATE ON table1
FOR EACH ROW
DECLARE
  temp temporada.temporada_id%type;
BEGIN
  Select temporada_id Into temp From competicio Where competicio_id = :new.competicio_id;
  modul_estadistic.actualitza_M_E_C2(:new.competicio_id);
  modul_estadistic.actualitza_M_E_C6(:new.competicio_id, temp);
  modul_estadistic.actualitza_M_E_C7();
END;
/
ALTER TRIGGER "SYSTEM"."TGR_PARTIT_0" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_TEMPORADA_ACTUAL
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_TEMPORADA_ACTUAL" 
BEFORE INSERT OR UPDATE ON TEMPORADA 
FOR EACH ROW
BEGIN
  -- La temporada de la competici que era actual deixa de ser-ho en inserir una nova temporada actual
  if ((:new.anterior_id != 0) AND (:new.temporada_actual = 1)) then
    update temporada set temporada_actual = 0 where temporada_id = :new.anterior_id and temporada_actual = 1;
  end if;
END;
/
ALTER TRIGGER "SYSTEM"."TGR_TEMPORADA_ACTUAL" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TGR_TEMPORADA_0
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TGR_TEMPORADA_0" 
-- AFTER INSERT OR UPDATE ON TEMPORADA 
AFTER INSERT OR UPDATE ON table1
BEGIN
  modul_estadistic.actualitza_M_E_C7();
END;
/
ALTER TRIGGER "SYSTEM"."TGR_TEMPORADA_0" ENABLE;
--------------------------------------------------------
--  DDL for Trigger TRG_ESTADISTIQUES_P_J_B
--------------------------------------------------------

  CREATE OR REPLACE TRIGGER "SYSTEM"."TRG_ESTADISTIQUES_P_J_B" 
BEFORE INSERT ON ESTADISTIQUES_P_J 
for each row 
declare
  n number;
begin
  /*n := :old.pt + :old.t1e + :old.t2e + :old.t3e + :old.rd + :old.ro + :old.ass + :old.tf + :old.pr - :old.t1i - :old.t2i - :old.t3i - :old.tc - :old.pp - :old.fc;
  :new.v := n;
  :new.vp := n * 10;*/
  null;
END;
/
ALTER TRIGGER "SYSTEM"."TRG_ESTADISTIQUES_P_J_B" ENABLE;
--------------------------------------------------------
--  DDL for Package ABM
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "SYSTEM"."ABM" AS 
/**	
    NOM DEL PAQUET: ABM
    FUNCIONALITAT: Proporciona les operaciones necessries per fer les altes, les baixes i les modificacions de JUGADORS, CONTRACTES i PARTITS.
**/


  /** NOM DEL PROCEDIMENT: jugador_alta
      FUNCIONALITAT: Permet donar d'alta un jugador 
      PARMETRES D'ENTRADA: excepte JUGADOR_ID, tots els camps de la taula JUGADOR
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure jugador_alta(
    p_NACIONALITAT_ID     IN JUGADOR.NACIONALITAT_ID%type, 
    p_FEDERACIO_ID        IN JUGADOR.FEDERACIO_ID%type ,
    p_NUMERO_FEDERAT      IN JUGADOR.NUMERO_FEDERAT%type ,
    p_NOM                 IN JUGADOR.NOM%type ,
    p_DATA_NAIXEMENT      IN JUGADOR.DATA_NAIXEMENT%type ,
    p_ALADA              IN JUGADOR.ALADA%type ,
    p_PES                 IN JUGADOR.PES%type ,
    p_POSICIO_ID          IN JUGADOR.POSICIO_ID%type ,
    p_REPRESENTANT_ID     IN JUGADOR.REPRESENTANT_ID%type ,
    p_URL_WEB             IN JUGADOR.URL_WEB%type DEFAULT NULL ,
    p_URL_VIDEO_PROMOCIO  IN JUGADOR.URL_VIDEO_PROMOCIO%type DEFAULT NULL ,
    p_ACTIVITAT_ID        IN JUGADOR.ACTIVITAT_ID%type ,
    p_ESTAT_ID            IN JUGADOR.ESTAT_ID%type ,
    p_SUB_ESTAT_ID        IN JUGADOR.SUB_ESTAT_ID%type ,
    p_DIAGNOSTIC          IN JUGADOR.DIAGNOSTIC%type DEFAULT NULL ,
    p_DATA_DISPONIBILITAT IN JUGADOR.DATA_DISPONIBILITAT%type DEFAULT NULL ,
    p_GENERE_ID           IN JUGADOR.GENERE_ID%type ,
    p_modalitat_id        in jugador.modalitat_id%type ,
    RSP OUT LOG_CRIDES.RSP%TYPE);
  
  
  /** NOM DEL PROCEDIMENT: jugador_baixa
      FUNCIONALITAT: Permet donar de baixa un jugador 
      PARMETRES D'ENTRADA: p_JUGADOR_ID
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure jugador_baixa(
    p_JUGADOR_ID          IN JUGADOR.JUGADOR_ID%type ,
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: jugador_baixa
      FUNCIONALITAT: Permet donar de baixa un jugador 
      PARMETRES D'ENTRADA: FEDERACIO_ID, NUMERO_FEDERAT
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure jugador_baixa(
    p_FEDERACIO_ID   IN JUGADOR.FEDERACIO_ID%type ,
    p_NUMERO_FEDERAT IN JUGADOR.NUMERO_FEDERAT%type ,
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: jugador_modificaci
      FUNCIONALITAT: Permet modificar un jugador 
      PARMETRES D'ENTRADA: Tots camps de JUGADOR
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  procedure jugador_modificaci(
    p_JUGADOR_ID          IN JUGADOR.JUGADOR_ID%type ,
    p_NACIONALITAT_ID     IN JUGADOR.NACIONALITAT_ID%type, 
    p_FEDERACIO_ID        IN JUGADOR.FEDERACIO_ID%type ,
    p_NUMERO_FEDERAT      IN JUGADOR.NUMERO_FEDERAT%type ,
    p_NOM                 IN JUGADOR.NOM%type ,
    p_DATA_NAIXEMENT      IN JUGADOR.DATA_NAIXEMENT%type ,
    p_ALADA              IN JUGADOR.ALADA%type ,
    p_PES                 IN JUGADOR.PES%type ,
    p_POSICIO_ID          IN JUGADOR.POSICIO_ID%type ,
    p_REPRESENTANT_ID     IN JUGADOR.REPRESENTANT_ID%type ,
    p_URL_WEB             IN JUGADOR.URL_WEB%type DEFAULT NULL ,
    p_URL_VIDEO_PROMOCIO  IN JUGADOR.URL_VIDEO_PROMOCIO%type DEFAULT NULL ,
    p_ACTIVITAT_ID        IN JUGADOR.ACTIVITAT_ID%type ,
    p_ESTAT_ID            IN JUGADOR.ESTAT_ID%type ,
    p_SUB_ESTAT_ID        IN JUGADOR.SUB_ESTAT_ID%type ,
    p_DIAGNOSTIC          IN JUGADOR.DIAGNOSTIC%type DEFAULT NULL ,
    p_DATA_DISPONIBILITAT IN JUGADOR.DATA_DISPONIBILITAT%type DEFAULT NULL ,
    p_GENERE_ID           IN JUGADOR.GENERE_ID%type ,
    p_MODALITAT_ID        IN JUGADOR.MODALITAT_ID%type ,
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: contracte_alta
      FUNCIONALITAT: Permet donar d'alta un contracte
      PARMETRES D'ENTRADA: excepte CONTRACTE_ID, tots els camps de la taula CONTRACTE
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure contracte_alta(
    p_DATA_SIGNATURA              IN CONTRACTE.DATA_SIGNATURA%type ,
    p_JUGADOR_ID                  IN CONTRACTE.JUGADOR_ID%type ,
    p_EQUIP_COMPRADOR_ID          IN CONTRACTE.EQUIP_COMPRADOR_ID%type ,
    p_EQUIP_VENEDOR_ID            IN CONTRACTE.EQUIP_VENEDOR_ID%type ,
    p_DURADA_CONTRACTE            IN CONTRACTE.DURADA_CONTRACTE%type ,
    p_SALARI_BRUT_ANUAL           IN CONTRACTE.SALARI_BRUT_ANUAL%type ,
    p_COMPENSACIO_A_EQUIP_VENEDOR IN CONTRACTE.COMPENSACIO_A_EQUIP_VENEDOR%type ,
    p_REPRESENTANT_ID             IN CONTRACTE.REPRESENTANT_ID%type,
    p_DATA_FINAL_CONTRACTE        IN CONTRACTE.DATA_FINAL_CONTRACTE%type ,
    p_ULTIM                       IN CONTRACTE.ULTIM%type ,
    p_PRIMERA_TEMPORADA_ID        IN CONTRACTE.PRIMERA_TEMPORADA_ID%TYPE ,
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: contracte_baixa
      FUNCIONALITAT: Permet donar de baixa un contracte 
      PARMETRES D'ENTRADA: CONTRACTE_ID
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure contracte_baixa(
    p_CONTRACTE_ID                IN CONTRACTE.CONTRACTE_ID%type ,
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: contracte_modificacio
      FUNCIONALITAT: Permet modificar un contracte 
      PARMETRES D'ENTRADA: Tots camps de la taula CONTRACTE
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure contracte_modificacio(
    p_CONTRACTE_ID                IN CONTRACTE.CONTRACTE_ID%type ,
    p_DATA_SIGNATURA              IN CONTRACTE.DATA_SIGNATURA%type ,
    p_JUGADOR_ID                  IN CONTRACTE.JUGADOR_ID%type ,
    p_EQUIP_COMPRADOR_ID          IN CONTRACTE.EQUIP_COMPRADOR_ID%type ,
    p_EQUIP_VENEDOR_ID            IN CONTRACTE.EQUIP_VENEDOR_ID%type ,
    p_DURADA_CONTRACTE            IN CONTRACTE.DURADA_CONTRACTE%type ,
    p_SALARI_BRUT_ANUAL           IN CONTRACTE.SALARI_BRUT_ANUAL%type ,
    p_COMPENSACIO_A_EQUIP_VENEDOR IN CONTRACTE.COMPENSACIO_A_EQUIP_VENEDOR%type ,
    p_VALOR_OPERACIO              IN CONTRACTE.VALOR_OPERACIO%type ,
    p_REPRESENTANT_ID             IN CONTRACTE.REPRESENTANT_ID%type,
    p_DATA_FINAL_CONTRACTE        IN CONTRACTE.DATA_FINAL_CONTRACTE%type ,
    p_ULTIM                       IN CONTRACTE.ULTIM%type , 
    p_PRIMERA_TEMPORADA_ID        IN CONTRACTE.PRIMERA_TEMPORADA_ID%TYPE ,
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: partit_alta
      FUNCIONALITAT: Permet donar d'alta un partit
      PARMETRES D'ENTRADA: excepte PARTIT_ID, tots els camps de la taula PARTIT
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure partit_alta(
    p_DATA_HORA         IN PARTIT.DATA_HORA%type ,
    p_MUNICIPI          IN PARTIT.MUNICIPI%type ,
    p_PAVELLO           IN PARTIT.PAVELLO%type ,
    p_EQUIP_LOCAL_ID    IN PARTIT.EQUIP_LOCAL_ID%type ,
    p_EQUIP_VISITANT_ID IN PARTIT.EQUIP_VISITANT_ID%type ,
    p_COMPETICIO_ID     IN PARTIT.COMPETICIO_ID%type ,
    p_ARBITRE_P_ID      IN PARTIT.ARBITRE_P_ID%type ,
    p_L1_ID             IN PARTIT.L1_ID%type ,
    p_L2_ID             IN PARTIT.L2_ID%type ,
    p_L3_ID             IN PARTIT.L3_ID%type ,
    p_L4_ID             IN PARTIT.L4_ID%type ,
    p_L5_ID             IN PARTIT.L5_ID%type ,
    p_L6_ID             IN PARTIT.L6_ID%type ,
    p_L7_ID             IN PARTIT.L7_ID%type ,
    p_L8_ID             IN PARTIT.L8_ID%type ,
    p_L9_ID             IN PARTIT.L9_ID%type ,
    p_L10_ID            IN PARTIT.L10_ID%type ,
    p_L11_ID            IN PARTIT.L11_ID%type ,
    p_L12_ID            IN PARTIT.L12_ID%type ,
    p_V1_ID             IN PARTIT.V1_ID%type ,
    p_V2_ID             IN PARTIT.V2_ID%type ,
    p_V3_ID             IN PARTIT.V3_ID%type ,
    p_V4_ID             IN PARTIT.V4_ID%type ,
    p_V5_ID             IN PARTIT.V5_ID%type ,
    p_V6_ID             IN PARTIT.V6_ID%type ,
    p_V7_ID             IN PARTIT.V7_ID%type ,
    p_V8_ID             IN PARTIT.V8_ID%type ,
    p_V9_ID             IN PARTIT.V9_ID%type ,
    p_V10_ID            IN PARTIT.V10_ID%type ,
    p_V11_ID            IN PARTIT.V11_ID%type ,
    p_V12_ID            IN PARTIT.V12_ID%type ,
    p_ARBITRE_AUX1_ID   IN PARTIT.ARBITRE_AUX1_ID%type ,
    p_ARBITRE_AUX2_ID   IN PARTIT.ARBITRE_AUX2_ID%type ,
    p_ARBITRE_AUX3_ID   IN PARTIT.ARBITRE_AUX3_ID%type DEFAULT NULL ,
    RSP OUT varchar2);

  
  /** NOM DEL PROCEDIMENT: partit_baixa
      FUNCIONALITAT: Permet donar de baixa un partit 
      PARMETRES D'ENTRADA: PARTIT_ID
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure partit_baixa(
    p_PARTIT_ID         IN PARTIT.PARTIT_ID%type ,
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: partit_modificacio
      FUNCIONALITAT: Permet modificar un partit 
      PARMETRES D'ENTRADA: Tots els camps de la taula PARTIT
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure partit_modificacio(
    p_PARTIT_ID         IN PARTIT.PARTIT_ID%type ,
    p_DATA_HORA         IN PARTIT.DATA_HORA%type ,
    p_MUNICIPI          IN PARTIT.MUNICIPI%type ,
    p_PAVELLO           IN PARTIT.PAVELLO%type ,
    p_EQUIP_LOCAL_ID    IN PARTIT.EQUIP_LOCAL_ID%type ,
    p_EQUIP_VISITANT_ID IN PARTIT.EQUIP_VISITANT_ID%type ,
    p_COMPETICIO_ID     IN PARTIT.COMPETICIO_ID%type ,
    p_ARBITRE_P_ID      IN PARTIT.ARBITRE_P_ID%type ,
    p_L1_ID             IN PARTIT.L1_ID%type ,
    p_L2_ID             IN PARTIT.L2_ID%type ,
    p_L3_ID             IN PARTIT.L3_ID%type ,
    p_L4_ID             IN PARTIT.L4_ID%type ,
    p_L5_ID             IN PARTIT.L5_ID%type ,
    p_L6_ID             IN PARTIT.L6_ID%type ,
    p_L7_ID             IN PARTIT.L7_ID%type ,
    p_L8_ID             IN PARTIT.L8_ID%type ,
    p_L9_ID             IN PARTIT.L9_ID%type ,
    p_L10_ID            IN PARTIT.L10_ID%type ,
    p_L11_ID            IN PARTIT.L11_ID%type ,
    p_L12_ID            IN PARTIT.L12_ID%type ,
    p_V1_ID             IN PARTIT.V1_ID%type ,
    p_V2_ID             IN PARTIT.V2_ID%type ,
    p_V3_ID             IN PARTIT.V3_ID%type ,
    p_V4_ID             IN PARTIT.V4_ID%type ,
    p_V5_ID             IN PARTIT.V5_ID%type ,
    p_V6_ID             IN PARTIT.V6_ID%type ,
    p_V7_ID             IN PARTIT.V7_ID%type ,
    p_V8_ID             IN PARTIT.V8_ID%type ,
    p_V9_ID             IN PARTIT.V9_ID%type ,
    p_V10_ID            IN PARTIT.V10_ID%type ,
    p_V11_ID            IN PARTIT.V11_ID%type ,
    p_V12_ID            IN PARTIT.V12_ID%type ,
    p_ARBITRE_AUX1_ID   IN PARTIT.ARBITRE_AUX1_ID%type ,
    p_ARBITRE_AUX2_ID   IN PARTIT.ARBITRE_AUX2_ID%type ,
    p_ARBITRE_AUX3_ID   IN PARTIT.ARBITRE_AUX3_ID%type DEFAULT NULL ,
    RSP OUT varchar2);

    
  /** NOM DEL PROCEDIMENT: inserta_log
      FUNCIONALITAT: Permet fer un registre dels procediments cridats, els parmetres d'entrada i els de sortida
      PARMETRES D'ENTRADA: paquet del procediment que crida al log
                            procediment que crida al log
                            entrada: parmetres d'entrada al procediment que crida al log
                            sortida: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
                            inici: moment en que comena el procediment que crida al log
                            final: moment en que acaba el procediment que crida al log
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure inserta_log(
    p_paquet IN varchar2, 
    p_procediment IN varchar2, 
    p_entrada IN varchar2, 
    p_sortida IN varchar2, 
    p_inici IN timestamp, 
    p_final IN timestamp);
END ABM;

/
--------------------------------------------------------
--  DDL for Package CONSULTES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "SYSTEM"."CONSULTES" AS 
/**	
    NOM DEL PAQUET: CONSULTES
    FUNCIONALITAT: Proporciona les operaciones necessries per fer les consultes.
**/


  /** NOM DEL REGISTRE: reg_consulta_a
      FUNCIONALITAT: Permet emmagatzemar les dades del cursor de la consulta, totes les dades del jugador i la data del final del seu ltim contracte
  **/
  TYPE reg_consulta_a IS RECORD
  (
    JUGADOR_ID JUGADOR.JUGADOR_ID%type,
    NACIONALITAT_ID JUGADOR.NACIONALITAT_ID%type, 
    FEDERACIO_ID JUGADOR.FEDERACIO_ID%type, 
    NUMERO_FEDERAT JUGADOR.NUMERO_FEDERAT%type, 
    NOM JUGADOR.NOM%type, 
    DATA_NAIXEMENT JUGADOR.DATA_NAIXEMENT%type, 
    ALADA JUGADOR.ALADA%type, 
    PES JUGADOR.PES%type, 
    POSICIO_ID JUGADOR.POSICIO_ID%type, 
    REPRESENTANT_ID JUGADOR.REPRESENTANT_ID%type, 
    URL_WEB JUGADOR.URL_WEB%type, 
    URL_VIDEO_PROMOCIO JUGADOR.URL_VIDEO_PROMOCIO%type, 
    ACTIVITAT_ID JUGADOR.ACTIVITAT_ID%type, 
    ESTAT_ID JUGADOR.ESTAT_ID%type, 
    SUB_ESTAT_ID JUGADOR.SUB_ESTAT_ID%type, 
    DIAGNOSTIC JUGADOR.DIAGNOSTIC%type, 
    DATA_DISPONIBILITAT JUGADOR.DATA_DISPONIBILITAT%type, 
    GENERE_ID JUGADOR.GENERE_ID%type,
    MODALITAT_ID JUGADOR.MODALITAT_ID%type,
    DATA_FINAL_CONTRACTE contracte.data_final_contracte%TYPE
  );


  /** NOM DEL REGISTRE: reg_consulta_b
      FUNCIONALITAT: Permet emmagatzemar les dades del cursor de la consulta
  **/  
  TYPE reg_consulta_b IS RECORD
  (
    competicio_nom competicio.competicio%type,
    equip_nom EQUIP.EQUIP%type,
    punts_a_favor number
  );


  /** NOM DEL REGISTRE: reg_consulta_c
      FUNCIONALITAT: Permet emmagatzemar les dades del cursor de la consulta
  **/ 
  TYPE reg_consulta_c IS RECORD
  (
    pos_id JUGADOR.POSICIO_ID%type,
    pos POSICIO.POSICIO%type,
    nom JUGADOR.NOM%type,
    valoracio ESTADISTIQUES_P_J.V%type
  );


  /** NOM DEL REGISTRE: reg_consulta_d
      FUNCIONALITAT: Permet emmagatzemar les dades del cursor de la consulta
  **/ 
  TYPE reg_consulta_d IS RECORD
  (
    representant_id CONTRACTE.REPRESENTANT_ID%type,
    rep REPRESENTANT.REPRESENTANT%type,
    contracte_id CONTRACTE.CONTRACTE_ID%type,
    valor_operacio CONTRACTE.VALOR_OPERACIO%type
  );


  /** NOM DEL REGISTRE: reg_consulta_e
      FUNCIONALITAT: Permet emmagatzemar les dades del cursor de la consulta
  **/ 
  TYPE reg_consulta_e IS RECORD
  (
    equip_nom EQUIP.EQUIP%type,
    quantitat number
  );


  /** NOM DEL REGISTRE: reg_consulta_f
      FUNCIONALITAT: Permet emmagatzemar les dades del cursor de la consulta
  **/ 
  TYPE reg_consulta_f IS RECORD
  (
    jugador_id JUGADOR.JUGADOR_ID%type,
    nom JUGADOR.NOM%type
  );


  /** NOM DEL PROCEDIMENT: jugadors_competicio
      FUNCIONALITAT: Retorna el llistat de tots els jugadors duna competici donada amb totes les seves dades, incloent la data de finalitzaci de contracte actual.
      PARMETRES D'ENTRADA: competicio_id
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --(Consulta a) El llistat de tots els jugadors duna competici donada amb totes les seves dades, incloent la data de finalitzaci de contracte actual.
  procedure jugadors_competicio(
    p_competicio_id IN COMPETICIO.COMPETICIO_ID%type, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: equips_competicio
      FUNCIONALITAT: Retorna el llistat de tots els equips d'una competici ordenats pel nombre de punts totals a favor en la temporada actual.
      PARMETRES D'ENTRADA: competicio_id
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  --(Consulta b) El llistat de tots els equips d'una competici ordenats pel nombre de punts totals a favor en la temporada actual.
  procedure equips_competicio(
    p_competicio_id IN COMPETICIO.COMPETICIO_ID%type, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: ll_5_millors_jugadors
      FUNCIONALITAT: Retorna el llistat dels 5 millors jugadors per posici en funci de la seva valoraci.
      PARMETRES D'ENTRADA: ambit_id, genere_id i modalitat_id
      PARMETRES DE SORTIDA: cursor_base, cont el llistat dels 5 millors jugadors de la posici base.
                             cursor_escorta, cont el llistat dels 5 millors jugadors de la posici escorta.
                             cursor_aler, cont el llistat dels 5 millors jugadors de la posici aler.
                             cursor_aler_pivot, cont el llistat dels 5 millors jugadors de la posici aler_pivot.
                             cursor_pivot, cont el llistat dels 5 millors jugadors de la posici pivot.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  --(Consulta c) Donats un mbit, un gnere i una modalitat de competici, el llistat dels 5 millors jugadors per posici en funci de la seva valoraci.
  procedure ll_5_millors_jugadors(
    p_ambit_id IN AMBIT.AMBIT_ID%type, 
    p_genere_id IN GENERE.GENERE_ID%type, 
    p_modalitat_id IN MODALITAT.MODALITAT_ID%type, 
    p_cursor_base OUT SYS_REFCURSOR, 
    p_cursor_escorta OUT SYS_REFCURSOR, 
    p_cursor_aler OUT SYS_REFCURSOR, 
    p_cursor_aler_pivot OUT SYS_REFCURSOR, 
    p_cursor_pivot OUT SYS_REFCURSOR, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: contractes_any
      FUNCIONALITAT: Retorna el nmero de contractes de jugadors signats i el valor econmic total de cadascun d'ells.
      PARMETRES D'ENTRADA: any i representant_id
      PARMETRES DE SORTIDA: n, nmero de contractes de jugadors signats
                             cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  --(Consulta d) Donat un any i un representant de jugadors, el nmero de contractes de jugadors signats i el valor econmic total de cadascun d'ells.
  procedure contractes_any(
    p_any IN number, 
    p_representant_id IN REPRESENTANT.REPRESENTANT_ID%type, 
    p_n OUT number, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: ll_10_equips_major_gast
      FUNCIONALITAT: Retorna el llistat dels 10 equips que ms diners shan gastat en adquisici de jugadors, ordenat de ms a menys.
      PARMETRES D'ENTRADA: any
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  --(Consulta e) Donat un any concret el llistat dels 10 equips que ms diners shan gastat en adquisici de jugadors, ordenat de ms a menys.
  procedure ll_10_equips_major_gast(
    p_any IN number, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: ll_jugadors_estaran_lliures
      FUNCIONALITAT: Retorna el llistat de jugadors que acaben contracte a final de la present temporada o que estan en actiu per sense equip.
      PARMETRES D'ENTRADA: pais_id, genere_id i modalitat_id
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  --(Consulta f) Donat un pas, un gnere i una modalitat, el llistat de jugadors que acaben contracte a final de la present temporada o que estan en actiu per sense equip.
  procedure LL_JUGADORS_ESTARAN_LLIURES(
    p_pais_id in PAIS.PAIS_ID%type, 
    p_genere_id in GENERE.GENERE_ID%type, 
    p_modalitat_id IN MODALITAT.MODALITAT_ID%type, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2);

  
  /** NOM DEL PROCEDIMENT: inserta_log
      FUNCIONALITAT: Permet fer un registre dels procediments cridats, els parmetres d'entrada i els de sortida
      PARMETRES D'ENTRADA: paquet del procediment que crida al log
                            procediment que crida al log
                            entrada: parmetres d'entrada al procediment que crida al log
                            sortida: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
                            inici: moment en que comena el procediment que crida al log
                            final: moment en que acaba el procediment que crida al log
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  procedure inserta_log(
    p_paquet IN varchar2, 
    p_procediment IN varchar2, 
    p_entrada IN varchar2, 
    p_sortida IN varchar2, 
    p_inici IN timestamp, 
    p_final IN timestamp);
  
END CONSULTES;

/
--------------------------------------------------------
--  DDL for Package MODUL_ESTADISTIC
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE "SYSTEM"."MODUL_ESTADISTIC" AS 
/**	
    NOM DEL PAQUET: MODUL_ESTADISTIC
    FUNCIONALITAT: Proporciona les operaciones necessries per fer les consultes i les actualitzacions del mdul estadstic.
**/


  /** NOM DEL PROCEDIMENT: n_total_jugadors_en_actiu
      FUNCIONALITAT: Retorna el nmero total de jugadors en actiu en tots els gneres i modalitats.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: n, el nmero total de jugadors en actiu en tots els gneres i modalitats.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  --Consulta 1. El nmero total de jugadors en actiu en tots els gneres i modalitats.
  procedure n_total_jugadors_en_actiu(
    p_n OUT m_e_c1.jugadors_actius%type, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C1
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades de nmero total de jugadors en actiu en tots els gneres i modalitats.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/   
  procedure actualitza_M_E_C1;


  /** NOM DEL PROCEDIMENT: maxim_anotador
      FUNCIONALITAT: Retorna, donada una competici, el seu mxim anotador en la temporada en curs (o b la darrera temporada, si ens trobem en el perode entre temporades).
      PARMETRES D'ENTRADA: competicio_id
      PARMETRES DE SORTIDA: competicio, temporada, jugador_id, nom (del jugador).
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  --Consulta 2. Donada una competici, el seu mxim anotador en la temporada en curs (o b la darrera temporada, si ens trobem en el perode entre temporades).
  procedure maxim_anotador(
    p_competicio_id IN competicio.competicio_id%type, 
    p_competicio OUT COMPETICIO.COMPETICIO%type, 
    p_temporada OUT temporada.temporada%type, 
    p_jugador_id OUT JUGADOR.JUGADOR_ID%type, 
    p_nom OUT JUGADOR.NOM%type, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C2
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades de mxim anotador en la temporada en curs (o b la darrera temporada, si ens trobem en el perode entre temporades) donada una competici.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/   
  procedure actualitza_M_E_C2(p_competicio_id IN competicio.competicio_id%type);


  /** NOM DEL PROCEDIMENT: jugador_mes_ben_pagat
      FUNCIONALITAT: Retorna el jugador ms ben pagat de cada modalitat i gnere.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: Identificador del jugador, nom i salari brut anual per a cada una de les modalitats i gneres.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  --Consulta 3. El jugador ms ben pagat de cada modalitat i gnere.
  procedure jugador_mes_ben_pagat(
  p_j_m1_g1 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m1_g1 OUT JUGADOR.NOM%type, p_s_m1_g1 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
  p_j_m1_g2 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m1_g2 OUT JUGADOR.NOM%type, p_s_m1_g2 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
  p_j_m2_g1 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m2_g1 OUT JUGADOR.NOM%type, p_s_m2_g1 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
  p_j_m2_g2 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m2_g2 OUT JUGADOR.NOM%type, p_s_m2_g2 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
  RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C3
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del jugador ms ben pagat de cada modalitat i gnere.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/  
  procedure actualitza_M_E_C3;


  /** NOM DEL PROCEDIMENT: jugador_mes_guanys_acumulats
      FUNCIONALITAT: Retorna el jugador amb ms guanys acumulats al llarg de tota la seva carrera esportiva
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: jugador_id, identificador del jugador.
                             nom, nom del jugador.
                             guanys, guans acumulats del jugador.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  --Consulta 4. El jugador amb ms guanys acumulats al llarg de tota la seva carrera esportiva.
  procedure jugador_mes_guanys_acumulats(
    p_jugador_id OUT JUGADOR.JUGADOR_ID%type, 
    p_nom OUT JUGADOR.NOM%type, 
    p_guanys OUT CONTRACTE.VALOR_OPERACIO%type, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C4
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del jugador amb ms guanys acumulats al llarg de tota la seva carrera esportiva.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/
  procedure actualitza_M_E_C4;


  /** NOM DEL PROCEDIMENT: sou_mig_anual
      FUNCIONALITAT: Retorna el sou mig anual dels jugadors donat un pas, una temporada, un gnere i una modalitat.
      PARMETRES D'ENTRADA: federacio_id, identificador de la federaci del jugador (pas al que ha jugat).
                            temporada_id, identificador de la temporada.
                            genere_id, identificador del gnere del jugador.
                            modalitat_id, identificador de la modalitat del jugador.
      PARMETRES DE SORTIDA: sou_mig_anual, sou mig anual dels jugadors donat un pas, una temporada, un gnere i una modalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --Consulta 5. Donat un pas, una temporada, un gnere i una modalitat, el sou mig anual dels jugadors.
  procedure sou_mig_anual(
    p_federacio_id IN JUGADOR.FEDERACIO_ID%type, 
    p_temporada_id IN temporada.temporada_id%type, 
    p_genere_id IN JUGADOR.GENERE_ID%type, 
    p_modalitat_id IN JUGADOR.MODALITAT_ID%type, 
    p_sou_mig_anual OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C5
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del sou mig anual dels jugadors donat un pas, una temporada, un gnere i una modalitat.
      PARMETRES D'ENTRADA: federacio_id, identificador de la federaci del jugador (pas al que ha jugat).
                            temporada_id, identificador de la temporada.
                            genere_id, identificador del gnere del jugador.
                            modalitat_id, identificador de la modalitat del jugador.
      PARMETRES DE SORTIDA: 
  **/  
  procedure actualitza_M_E_C5(
    p_federacio_id IN JUGADOR.FEDERACIO_ID%type, 
    p_temporada_id IN temporada.temporada_id%type, 
    p_genere_id IN JUGADOR.GENERE_ID%type, 
    p_modalitat_id IN JUGADOR.MODALITAT_ID%type);


  /** NOM DEL PROCEDIMENT: millors_equips
      FUNCIONALITAT: Retorna els millors equips ofensius i defensius donada una competici i una temporada.
      PARMETRES D'ENTRADA: competicio_id, identificador de la competici.
                            temporada_id, identificador de la temporada.
      PARMETRES DE SORTIDA: competicio, nom de la competici.
                             millor_ofensiu_id, Identificador del millor equip ofensiu. 
                             millor_ofensiu_nom, nom del millor equip ofensiu.
                             millor_defensiu_id, Identificador del millor equip defensiu.
                             millor_defensiu_nom, nom del millor equip defensiu.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --Consulta 6. Donada una competici i una temporada, els millors equips ofensius i defensius.
  procedure millors_equips(
    p_competicio_id IN COMPETICIO.COMPETICIO_ID%type, 
    p_temporada_id IN temporada.temporada_id%type, 
    p_competicio OUT COMPETICIO.COMPETICIO%type, 
    p_millor_ofensiu_id OUT EQUIP.EQUIP_ID%type, 
    p_millor_ofensiu_nom OUT EQUIP.EQUIP%type, 
    p_millor_defensiu_id OUT EQUIP.EQUIP_ID%type, 
    p_millor_defensiu_nom OUT EQUIP.EQUIP%type, 
    RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C6
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades dels millors equips ofensius i defensius donada una competici i una temporada.
      PARMETRES D'ENTRADA: competicio_id, identificador de la competici.
                            temporada_id, identificador de la temporada.
      PARMETRES DE SORTIDA: 
  **/
  procedure actualitza_M_E_C6(
    p_competicio_id IN COMPETICIO.COMPETICIO_ID%type, 
    p_temporada_id IN temporada.temporada_id%type);


  /** NOM DEL PROCEDIMENT: millor_jugador_mon
      FUNCIONALITAT: Retorna el millor jugador del mn en el darrer any (mitjana de valoracions ponderades ms alta) per a cada gnere i modalitat.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: Identificador del jugador, nom i mitjana de valoracions ponderades per a cada una de les modalitats i gneres.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --Consulta 7. Per a cada gnere i modalitat, el millor jugador del mn en el darrer any (mitjana de valoracions ponderades ms alta).
  --procedure millor_jugador_mon(p_cursor OUT SYS_REFCURSOR, RSP OUT varchar2);
  procedure millor_jugador_mon(
  p_j_id_m1_g1 OUT JUGADOR.JUGADOR_ID%type, p_nom_m1_g1 OUT JUGADOR.NOM%type, p_mvp_m1_g1 OUT ESTADISTIQUES_P_J.VP%type, 
  p_j_id_m1_g2 OUT JUGADOR.JUGADOR_ID%type, p_nom_m1_g2 OUT JUGADOR.NOM%type, p_mvp_m1_g2 OUT ESTADISTIQUES_P_J.VP%type, 
  p_j_id_m2_g1 OUT JUGADOR.JUGADOR_ID%type, p_nom_m2_g1 OUT JUGADOR.NOM%type, p_mvp_m2_g1 OUT ESTADISTIQUES_P_J.VP%type, 
  p_j_id_m2_g2 OUT JUGADOR.JUGADOR_ID%type, p_nom_m2_g2 OUT JUGADOR.NOM%type, p_mvp_m2_g2 OUT ESTADISTIQUES_P_J.VP%type, 
  RSP OUT varchar2);


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C7
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del millor jugador del mn en el darrer any (mitjana de valoracions ponderades ms alta) per a cada gnere i modalitat.
      PARMETRES D'ENTRADA: competicio_id, identificador de la competici.
                            temporada_id, identificador de la temporada.
      PARMETRES DE SORTIDA: 
  **/
  procedure actualitza_M_E_C7;


  /** NOM DEL PROCEDIMENT: taula_jugador_canviada
      FUNCIONALITAT: Quan el trigger detecta insert or update on jugador aquest procediment fa les operacions d'actualitzaci del mdul estadstic.
      PARMETRES D'ENTRADA: jugador_id, identificador del jugador.
                            temporada_id, identificador de la temporada.
                            federacio_id, identificador de la federaci.
                            genere_id, identificador del gnere.
                            modalitat_id, identificador de la modalitat.
      PARMETRES DE SORTIDA: 
  **/
  procedure taula_jugador_canviada(
    p_temporada temporada.temporada_id%type, 
    p_federacio_id jugador.federacio_id%type, 
    p_genere_id jugador.genere_id%type, 
    p_modalitat_id jugador.modalitat_id%type);


  /** NOM DEL PROCEDIMENT: inserta_log
      FUNCIONALITAT: Permet fer un registre dels procediments cridats, els parmetres d'entrada i els de sortida
      PARMETRES D'ENTRADA: paquet del procediment que crida al log
                            procediment que crida al log
                            entrada: parmetres d'entrada al procediment que crida al log
                            sortida: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
                            inici: moment en que comena el procediment que crida al log
                            final: moment en que acaba el procediment que crida al log
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  procedure inserta_log(
    p_paquet IN varchar2, 
    p_procediment IN varchar2, 
    p_entrada IN varchar2, 
    p_sortida IN varchar2, 
    p_inici IN timestamp, 
    p_final IN timestamp);
END MODUL_ESTADISTIC;

/
--------------------------------------------------------
--  DDL for Package Body ABM
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "SYSTEM"."ABM" AS
/**	
    NOM DEL PAQUET: ABM
    FUNCIONALITAT: Proporciona les operaciones necessries per fer les altes, les baixes i les modificacions de JUGADORS, CONTRACTES i PARTITS.
**/


  /** NOM DEL PROCEDIMENT: jugador_alta
      FUNCIONALITAT: Permet donar d'alta un jugador 
      PARMETRES D'ENTRADA: excepte jugador_id, tots els de la taula JUGADOR
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure jugador_alta(
    p_NACIONALITAT_ID     IN JUGADOR.NACIONALITAT_ID%type, 
    p_FEDERACIO_ID        IN JUGADOR.FEDERACIO_ID%type ,
    p_NUMERO_FEDERAT      IN JUGADOR.NUMERO_FEDERAT%type ,
    p_NOM                 IN JUGADOR.NOM%type ,
    p_DATA_NAIXEMENT      IN JUGADOR.DATA_NAIXEMENT%type ,
    p_ALADA              IN JUGADOR.ALADA%type ,
    p_PES                 IN JUGADOR.PES%type ,
    p_POSICIO_ID          IN JUGADOR.POSICIO_ID%type ,
    p_REPRESENTANT_ID     IN JUGADOR.REPRESENTANT_ID%type ,
    p_URL_WEB             IN JUGADOR.URL_WEB%type DEFAULT NULL ,
    p_URL_VIDEO_PROMOCIO  IN JUGADOR.URL_VIDEO_PROMOCIO%type DEFAULT NULL ,
    p_ACTIVITAT_ID        IN JUGADOR.ACTIVITAT_ID%type ,
    p_ESTAT_ID            IN JUGADOR.ESTAT_ID%type ,
    p_SUB_ESTAT_ID        IN JUGADOR.SUB_ESTAT_ID%type ,
    p_DIAGNOSTIC          IN JUGADOR.DIAGNOSTIC%type DEFAULT NULL ,
    p_DATA_DISPONIBILITAT IN JUGADOR.DATA_DISPONIBILITAT%type DEFAULT NULL ,
    p_GENERE_ID           IN JUGADOR.GENERE_ID%type ,
    p_modalitat_id        in jugador.modalitat_id%type , 
    RSP OUT LOG_CRIDES.RSP%TYPE) AS
  v_inici timestamp;
  entrada varchar2(500);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'NACIONALITAT_ID = '||p_NACIONALITAT_ID||' FEDERACIO_ID = '||p_FEDERACIO_ID||' NUMERO_FEDERAT = '||p_NUMERO_FEDERAT||' NOM = '||p_NOM||' DATA_NAIXEMENT = '||p_DATA_NAIXEMENT||' ALADA = '||p_ALADA||' PES = '||p_PES||' POSICIO_ID = '||p_POSICIO_ID||' REPRESENTANT_ID = '||p_REPRESENTANT_ID||' URL_WEB = '||p_URL_WEB||' URL_VIDEO_PROMOCIO = '||p_URL_VIDEO_PROMOCIO||' ACTIVITAT_ID ='||p_ACTIVITAT_ID||' ESTAT_ID = '||p_ESTAT_ID||' SUB_ESTAT_ID = '||p_SUB_ESTAT_ID||' DIAGNOSTIC = '||p_DIAGNOSTIC||' DATA_DISPONIBILITAT = '||p_DATA_DISPONIBILITAT||' GENERE_ID = '||p_GENERE_ID||' MODALITAT_ID = '||p_MODALITAT_ID;

    INSERT
    INTO jugador
    VALUES
    (
      SEQ_JUGADOR_ID.nextval , -- Obtenir JUGADOR_ID de la seqncia
      p_NACIONALITAT_ID ,
      p_FEDERACIO_ID ,
      p_NUMERO_FEDERAT ,
      p_NOM ,
      p_DATA_NAIXEMENT ,
      p_ALADA ,
      p_PES ,
      p_POSICIO_ID ,
      p_REPRESENTANT_ID ,
      p_URL_WEB ,
      p_URL_VIDEO_PROMOCIO ,
      p_ACTIVITAT_ID ,
      p_ESTAT_ID ,
      p_SUB_ESTAT_ID ,
      p_DIAGNOSTIC ,
      p_DATA_DISPONIBILITAT ,
      p_GENERE_ID ,
      p_MODALITAT_ID 
    );
    
    -- modul_estadistic.taula_jugador_canviada(temp, :new.federacio_id, :new.genere_id, :new.modalitat_id);
    modul_estadistic.actualitza_M_E_C1();
    inserta_log('ABM', 'jugador_alta', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     when others then
       dbms_output.put_line ('ERROR '||sqlcode||sqlerrm);
       rsp := 'ERROR '||sqlerrm;
       inserta_log('ABM', 'jugador_alta', entrada, RSP, v_inici, systimestamp);
       -- raise_application_error (-20001, SQLERRM);    
  END jugador_alta;


  /** NOM DEL PROCEDIMENT: jugador_baixa
      FUNCIONALITAT: Permet donar de baixa un jugador 
      PARMETRES D'ENTRADA: jugador_id
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure jugador_baixa(
    p_JUGADOR_ID          IN JUGADOR.JUGADOR_ID%type ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  err_jugador_no_existeix EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'JUGADOR_ID = '||p_JUGADOR_ID;
    DELETE
    FROM JUGADOR
    WHERE JUGADOR_ID = p_JUGADOR_ID;
  
    if (sql%rowcount = 0) then
        raise err_jugador_no_existeix;
    end if;
    
    modul_estadistic.actualitza_M_E_C1();
    inserta_log('ABM', 'jugador_baixa', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     WHEN err_jugador_no_existeix THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR El jugador no existeix.');
      RSP := 'ERROR El jugador no existeix.';
      inserta_log('ABM', 'jugador_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'jugador_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END jugador_baixa;


  /** NOM DEL PROCEDIMENT: jugador_baixa
      FUNCIONALITAT: Permet donar de baixa un jugador 
      PARMETRES D'ENTRADA: FEDERACIO_ID, NUMERO_FEDERAT
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  procedure jugador_baixa(
    p_FEDERACIO_ID   IN JUGADOR.FEDERACIO_ID%type ,
    p_NUMERO_FEDERAT IN JUGADOR.NUMERO_FEDERAT%type ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  err_jugador_no_existeix EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'FEDERACIO_ID = '||p_FEDERACIO_ID||'NUMERO_FEDERAT = '||p_NUMERO_FEDERAT;
    DELETE
    FROM JUGADOR
    WHERE FEDERACIO_ID = p_FEDERACIO_ID
    AND NUMERO_FEDERAT = p_NUMERO_FEDERAT;
        
    if (sql%rowcount = 0) then
        raise err_jugador_no_existeix;
    end if;
    
    modul_estadistic.actualitza_M_E_C1();
    inserta_log('ABM', 'jugador_baixa', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     WHEN err_jugador_no_existeix THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR El jugador de la federaci no existeix.');
      RSP := 'ERROR El jugador de la federaci no existeix.';
      inserta_log('ABM', 'jugador_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'jugador_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END jugador_baixa;


  /** NOM DEL PROCEDIMENT: jugador_modificaci
      FUNCIONALITAT: Permet modificar un jugador 
      PARMETRES D'ENTRADA: Tots camps de la taula JUGADOR
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  procedure jugador_modificaci(
    p_JUGADOR_ID          IN JUGADOR.JUGADOR_ID%type ,
    p_NACIONALITAT_ID     IN JUGADOR.NACIONALITAT_ID%type, 
    p_FEDERACIO_ID        IN JUGADOR.FEDERACIO_ID%type ,
    p_NUMERO_FEDERAT      IN JUGADOR.NUMERO_FEDERAT%type ,
    p_NOM                 IN JUGADOR.NOM%type ,
    p_DATA_NAIXEMENT      IN JUGADOR.DATA_NAIXEMENT%type ,
    p_ALADA              IN JUGADOR.ALADA%type ,
    p_PES                 IN JUGADOR.PES%type ,
    p_POSICIO_ID          IN JUGADOR.POSICIO_ID%type ,
    p_REPRESENTANT_ID     IN JUGADOR.REPRESENTANT_ID%type ,
    p_URL_WEB             IN JUGADOR.URL_WEB%type DEFAULT NULL ,
    p_URL_VIDEO_PROMOCIO  IN JUGADOR.URL_VIDEO_PROMOCIO%type DEFAULT NULL ,
    p_ACTIVITAT_ID        IN JUGADOR.ACTIVITAT_ID%type ,
    p_ESTAT_ID            IN JUGADOR.ESTAT_ID%type ,
    p_SUB_ESTAT_ID        IN JUGADOR.SUB_ESTAT_ID%type ,
    p_DIAGNOSTIC          IN JUGADOR.DIAGNOSTIC%type DEFAULT NULL ,
    p_DATA_DISPONIBILITAT IN JUGADOR.DATA_DISPONIBILITAT%type DEFAULT NULL ,
    p_GENERE_ID           IN JUGADOR.GENERE_ID%type ,
    p_MODALITAT_ID        IN JUGADOR.MODALITAT_ID%type ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  err_jugador_no_existeix EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'JUGADOR_ID = '||p_JUGADOR_ID||' NACIONALITAT_ID = '||p_NACIONALITAT_ID||' FEDERACIO_ID = '||p_FEDERACIO_ID||' NUMERO_FEDERAT = '||p_NUMERO_FEDERAT||' NOM = '||p_NOM||' DATA_NAIXEMENT = '||p_DATA_NAIXEMENT||' ALADA = '||p_ALADA||' PES = '||p_PES||' POSICIO_ID = '||p_POSICIO_ID||' REPRESENTANT_ID = '||p_REPRESENTANT_ID||' URL_WEB = '||p_URL_WEB||' URL_VIDEO_PROMOCIO = '||p_URL_VIDEO_PROMOCIO||' ACTIVITAT_ID ='||p_ACTIVITAT_ID||' ESTAT_ID = '||p_ESTAT_ID||' SUB_ESTAT_ID = '||p_SUB_ESTAT_ID||' DIAGNOSTIC = '||p_DIAGNOSTIC||' DATA_DISPONIBILITAT = '||p_DATA_DISPONIBILITAT||' GENERE_ID = '||p_GENERE_ID||' MODALITAT_ID = '||p_MODALITAT_ID;
    UPDATE JUGADOR
    SET 
      NACIONALITAT_ID       = p_NACIONALITAT_ID ,
      FEDERACIO_ID          = p_FEDERACIO_ID ,
      NUMERO_FEDERAT        = p_NUMERO_FEDERAT ,
      NOM                   = p_NOM ,
      DATA_NAIXEMENT        = p_DATA_NAIXEMENT ,
      ALADA                = p_ALADA ,
      PES                   = p_PES ,
      POSICIO_ID            = p_POSICIO_ID ,
      REPRESENTANT_ID       = p_REPRESENTANT_ID ,
      URL_WEB               = p_URL_WEB ,
      URL_VIDEO_PROMOCIO    = p_URL_VIDEO_PROMOCIO ,
      ACTIVITAT_ID          = p_ACTIVITAT_ID ,
      ESTAT_ID              = p_ESTAT_ID ,
      SUB_ESTAT_ID          = p_SUB_ESTAT_ID ,
      DIAGNOSTIC            = p_DIAGNOSTIC ,
      DATA_DISPONIBILITAT   = p_DATA_DISPONIBILITAT ,
      GENERE_ID             = p_GENERE_ID ,
      MODALITAT_ID          = p_MODALITAT_ID
    WHERE JUGADOR_ID        = p_JUGADOR_ID;
    
    if (sql%rowcount = 0) then
        raise err_jugador_no_existeix;
    end if;
    
    modul_estadistic.actualitza_M_E_C1();
    inserta_log('ABM', 'jugador_modificaci', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     WHEN err_jugador_no_existeix THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR El jugador no existeix.');
      RSP := 'ERROR El jugador no existeix.';
      inserta_log('ABM', 'jugador_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'jugador_modificaci', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END jugador_modificaci;


  /** NOM DEL PROCEDIMENT: contracte_alta
      FUNCIONALITAT: Permet donar d'alta un contracte
      PARMETRES D'ENTRADA: excepte CONTRACTE_ID, tots els camps de la taula CONTRACTE
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure contracte_alta(
    p_DATA_SIGNATURA              IN CONTRACTE.DATA_SIGNATURA%type ,
    p_JUGADOR_ID                  IN CONTRACTE.JUGADOR_ID%type ,
    p_EQUIP_COMPRADOR_ID          IN CONTRACTE.EQUIP_COMPRADOR_ID%type ,
    p_EQUIP_VENEDOR_ID            IN CONTRACTE.EQUIP_VENEDOR_ID%type ,
    p_DURADA_CONTRACTE            IN CONTRACTE.DURADA_CONTRACTE%type ,
    p_SALARI_BRUT_ANUAL           IN CONTRACTE.SALARI_BRUT_ANUAL%type ,
    p_COMPENSACIO_A_EQUIP_VENEDOR IN CONTRACTE.COMPENSACIO_A_EQUIP_VENEDOR%type ,
    p_REPRESENTANT_ID             IN CONTRACTE.REPRESENTANT_ID%type,
    p_DATA_FINAL_CONTRACTE        IN CONTRACTE.DATA_FINAL_CONTRACTE%type ,
    p_ULTIM                       IN CONTRACTE.ULTIM%type ,
    p_PRIMERA_TEMPORADA_ID        IN CONTRACTE.PRIMERA_TEMPORADA_ID%TYPE ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  contracte_id CONTRACTE.CONTRACTE_ID%type;
  contador int;
  err_duracio_incorrecta EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'DATA_SIGNATURA = '||p_DATA_SIGNATURA||' JUGADOR_ID = '||p_JUGADOR_ID||' EQUIP_COMPRADOR_ID = '||p_EQUIP_COMPRADOR_ID||' EQUIP_VENEDOR_ID = '||p_EQUIP_VENEDOR_ID||' DURADA_CONTRACTE = '||p_DURADA_CONTRACTE||' SALARI_BRUT_ANUAL = '||p_SALARI_BRUT_ANUAL||' COMPENSACIO_A_EQUIP_VENEDOR ='||p_COMPENSACIO_A_EQUIP_VENEDOR||' REPRESENTANT_ID = '||p_REPRESENTANT_ID||' DATA_FINAL_CONTRACTE ='||p_DATA_FINAL_CONTRACTE||' ULTIM = '||p_ULTIM;
    IF (p_DURADA_CONTRACTE < 1) THEN
      raise err_duracio_incorrecta;
    END IF;
    
    contracte_id := SEQ_CONTRACTE_ID.nextval; -- Obtenir CONTRACTE_ID de la seqncia
    INSERT
    INTO CONTRACTE
    VALUES
    (
      contracte_id , 
      p_DATA_SIGNATURA ,
      p_JUGADOR_ID ,
      p_EQUIP_COMPRADOR_ID ,
      p_EQUIP_VENEDOR_ID ,
      p_DURADA_CONTRACTE ,
      p_SALARI_BRUT_ANUAL ,
      p_COMPENSACIO_A_EQUIP_VENEDOR ,
      p_COMPENSACIO_A_EQUIP_VENEDOR + p_SALARI_BRUT_ANUAL ,
      p_REPRESENTANT_ID ,
      p_DATA_FINAL_CONTRACTE ,
      p_ULTIM , 
      p_PRIMERA_TEMPORADA_ID
    );
    -- Alta de les lnies que vinculen el contracte a les temporades a la taula contracte_temporada
    contador := p_PRIMERA_TEMPORADA_ID;
    Loop
      Insert Into contracte_temporada Values (SEQ_CONTRACTE_TEMPORADA_ID.nextval, contracte_id, contador);
      contador := contador + 1;
    exit when (contador >= (p_PRIMERA_TEMPORADA_ID + p_DURADA_CONTRACTE)); 
    end loop;
      
    inserta_log('ABM', 'contracte_alta', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     WHEN err_duracio_incorrecta THEN
      DBMS_OUTPUT.PUT_LINE ('La duraci del contracte s menor que 1.');
      RSP := 'ERROR: La duraci del contracte s menor que 1.';
      inserta_log('ABM', 'contracte_alta', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, 'La duraci del contracte s menor que 1.');
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'contracte_alta', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END contracte_alta;


  /** NOM DEL PROCEDIMENT: contracte_baixa
      FUNCIONALITAT: Permet donar de baixa un contracte 
      PARMETRES D'ENTRADA: CONTRACTE_ID
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure contracte_baixa(
    p_CONTRACTE_ID                IN CONTRACTE.CONTRACTE_ID%type ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  err_contracte_no_existeix EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'CONTRACTE_ID = '||p_CONTRACTE_ID;
    delete
    from contracte_temporada
    where contracte_id   = p_contracte_id;
    
    DELETE
    FROM CONTRACTE
    WHERE CONTRACTE_ID   = p_CONTRACTE_ID;
    
    if (sql%rowcount = 0) then
        raise err_contracte_no_existeix;
    end if;
    inserta_log('ABM', 'contracte_baixa', entrada, RSP, v_inici, systimestamp);
    
    EXCEPTION
     WHEN err_contracte_no_existeix THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR El contracte no existeix.');
      RSP := 'ERROR El contracte no existeix.';
      inserta_log('ABM', 'contracte_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'contracte_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END contracte_baixa;


  /** NOM DEL PROCEDIMENT: contracte_modificacio
      FUNCIONALITAT: Permet modificar un contracte 
      PARMETRES D'ENTRADA: Tots camps de la taula CONTRACTE
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure contracte_modificacio(
    p_CONTRACTE_ID                IN CONTRACTE.CONTRACTE_ID%type ,
    p_DATA_SIGNATURA              IN CONTRACTE.DATA_SIGNATURA%type ,
    p_JUGADOR_ID                  IN CONTRACTE.JUGADOR_ID%type ,
    p_EQUIP_COMPRADOR_ID          IN CONTRACTE.EQUIP_COMPRADOR_ID%type ,
    p_EQUIP_VENEDOR_ID            IN CONTRACTE.EQUIP_VENEDOR_ID%type ,
    p_DURADA_CONTRACTE            IN CONTRACTE.DURADA_CONTRACTE%type ,
    p_SALARI_BRUT_ANUAL           IN CONTRACTE.SALARI_BRUT_ANUAL%type ,
    p_COMPENSACIO_A_EQUIP_VENEDOR IN CONTRACTE.COMPENSACIO_A_EQUIP_VENEDOR%type ,
    p_VALOR_OPERACIO              IN CONTRACTE.VALOR_OPERACIO%type ,
    p_REPRESENTANT_ID             IN CONTRACTE.REPRESENTANT_ID%type,
    p_DATA_FINAL_CONTRACTE        IN CONTRACTE.DATA_FINAL_CONTRACTE%type ,
    p_ULTIM                       IN CONTRACTE.ULTIM%type , 
    p_PRIMERA_TEMPORADA_ID        IN CONTRACTE.PRIMERA_TEMPORADA_ID%TYPE ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  err_contracte_no_existeix EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'CONTRACTE_ID = '||p_CONTRACTE_ID||' DATA_SIGNATURA = '||p_DATA_SIGNATURA||' JUGADOR_ID = '||p_JUGADOR_ID||' EQUIP_COMPRADOR_ID = '||p_EQUIP_COMPRADOR_ID||' EQUIP_VENEDOR_ID = '||p_EQUIP_VENEDOR_ID||' DURADA_CONTRACTE = '||p_DURADA_CONTRACTE||' SALARI_BRUT_ANUAL = '||p_SALARI_BRUT_ANUAL||' COMPENSACIO_A_EQUIP_VENEDOR ='||p_COMPENSACIO_A_EQUIP_VENEDOR||' VALOR_OPERACIO = '||p_VALOR_OPERACIO||' REPRESENTANT_ID = '||p_REPRESENTANT_ID||' DATA_FINAL_CONTRACTE ='||p_DATA_FINAL_CONTRACTE||' ULTIM = '||p_ULTIM;
    UPDATE CONTRACTE
    SET 
      DATA_SIGNATURA              = p_DATA_SIGNATURA ,
      JUGADOR_ID                  = p_JUGADOR_ID ,
      EQUIP_COMPRADOR_ID          = p_EQUIP_COMPRADOR_ID ,
      EQUIP_VENEDOR_ID            = p_EQUIP_VENEDOR_ID ,
      DURADA_CONTRACTE            = p_DURADA_CONTRACTE ,
      SALARI_BRUT_ANUAL           = p_SALARI_BRUT_ANUAL ,
      COMPENSACIO_A_EQUIP_VENEDOR = p_COMPENSACIO_A_EQUIP_VENEDOR ,
      VALOR_OPERACIO              = p_VALOR_OPERACIO ,
      REPRESENTANT_ID             = p_REPRESENTANT_ID ,
      DATA_FINAL_CONTRACTE        = p_DATA_FINAL_CONTRACTE ,
      ULTIM                       = p_ULTIM ,
      PRIMERA_TEMPORADA_ID        = p_PRIMERA_TEMPORADA_ID 
    WHERE CONTRACTE_ID            = p_CONTRACTE_ID;
    
    if (sql%rowcount = 0) then
        raise err_contracte_no_existeix;
    end if;
    inserta_log('ABM', 'contracte_modificacio', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     WHEN err_contracte_no_existeix THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR El contracte no existeix.');
      RSP := 'ERROR El contracte no existeix.';
      inserta_log('ABM', 'contracte_modificacio', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'contracte_modificacio', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END contracte_modificacio;


  /** NOM DEL PROCEDIMENT: partit_alta
      FUNCIONALITAT: Permet donar d'alta un partit
      PARMETRES D'ENTRADA: excepte PARTIT_ID, tots els camps de la taula PARTIT
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure partit_alta(
    p_DATA_HORA         IN PARTIT.DATA_HORA%type ,
    p_MUNICIPI          IN PARTIT.MUNICIPI%type ,
    p_PAVELLO           IN PARTIT.PAVELLO%type ,
    p_EQUIP_LOCAL_ID    IN PARTIT.EQUIP_LOCAL_ID%type ,
    p_EQUIP_VISITANT_ID IN PARTIT.EQUIP_VISITANT_ID%type ,
    p_COMPETICIO_ID     IN PARTIT.COMPETICIO_ID%type ,
    p_ARBITRE_P_ID      IN PARTIT.ARBITRE_P_ID%type ,
    p_L1_ID             IN PARTIT.L1_ID%type ,
    p_L2_ID             IN PARTIT.L2_ID%type ,
    p_L3_ID             IN PARTIT.L3_ID%type ,
    p_L4_ID             IN PARTIT.L4_ID%type ,
    p_L5_ID             IN PARTIT.L5_ID%type ,
    p_L6_ID             IN PARTIT.L6_ID%type ,
    p_L7_ID             IN PARTIT.L7_ID%type ,
    p_L8_ID             IN PARTIT.L8_ID%type ,
    p_L9_ID             IN PARTIT.L9_ID%type ,
    p_L10_ID            IN PARTIT.L10_ID%type ,
    p_L11_ID            IN PARTIT.L11_ID%type ,
    p_L12_ID            IN PARTIT.L12_ID%type ,
    p_V1_ID             IN PARTIT.V1_ID%type ,
    p_V2_ID             IN PARTIT.V2_ID%type ,
    p_V3_ID             IN PARTIT.V3_ID%type ,
    p_V4_ID             IN PARTIT.V4_ID%type ,
    p_V5_ID             IN PARTIT.V5_ID%type ,
    p_V6_ID             IN PARTIT.V6_ID%type ,
    p_V7_ID             IN PARTIT.V7_ID%type ,
    p_V8_ID             IN PARTIT.V8_ID%type ,
    p_V9_ID             IN PARTIT.V9_ID%type ,
    p_V10_ID            IN PARTIT.V10_ID%type ,
    p_V11_ID            IN PARTIT.V11_ID%type ,
    p_V12_ID            IN PARTIT.V12_ID%type ,
    p_ARBITRE_AUX1_ID   IN PARTIT.ARBITRE_AUX1_ID%type ,
    p_ARBITRE_AUX2_ID   IN PARTIT.ARBITRE_AUX2_ID%type ,
    p_ARBITRE_AUX3_ID   IN PARTIT.ARBITRE_AUX3_ID%type DEFAULT NULL ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  municipi varchar2(50);
  pavello varchar2(40);
  err_municipi EXCEPTION;
  err_pavello EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'DATA_HORA = '||p_DATA_HORA||' MUNICIPI = '||p_MUNICIPI||' PAVELLO = '||p_PAVELLO||' EQUIP_LOCAL_ID = '||p_EQUIP_LOCAL_ID||' EQUIP_VISITANT_ID = '||p_EQUIP_VISITANT_ID||' COMPETICIO_ID = '||p_COMPETICIO_ID||' ARBITRE_P_ID = '||p_ARBITRE_P_ID||' L1_ID = '||p_L1_ID||' L2_ID = '||p_L2_ID||' L3_ID = '||p_L3_ID||' L4_ID = '||p_L4_ID||' L5_ID = '||p_L5_ID||' L6_ID = '||p_L6_ID||' L7_ID = '||p_L7_ID||' L8_ID = '||p_L8_ID||' L9_ID = '||p_L9_ID||' L10_ID = '||p_L10_ID||' L11_ID = '||p_L11_ID||' L12_ID = '||p_L12_ID||' V1_ID = '|| p_V1_ID||' V2_ID = '||p_V2_ID||' V3_ID = '||p_V3_ID||' V4_ID = '||p_V4_ID||' V5_ID = '||p_V5_ID||' V6_ID = '||p_V6_ID||' V7_ID = '||p_V7_ID||' V8_ID = '||p_V8_ID||' V9_ID = '||p_V9_ID||' V10_ID = '||p_V10_ID||' V11_ID = '||p_V11_ID||' V12_ID = '||p_V12_ID||' ARBITRE_AUX1_ID = '||p_ARBITRE_AUX1_ID||' ARBITRE_AUX2_ID = '||p_ARBITRE_AUX2_ID||' ARBITRE_AUX3_ID = '||p_ARBITRE_AUX3_ID;
    -- Comprovar que es juga en el pavell de l'equip local
    Select municipi_pavello Into municipi From equip Where equip_id = p_EQUIP_LOCAL_ID;
    Select pavello Into pavello From equip Where equip_id = p_EQUIP_LOCAL_ID;
    IF NOT (p_MUNICIPI = municipi) Then
        raise err_municipi;
    end if;
    IF NOT (p_PAVELLO = pavello) Then
        raise err_pavello;
    end if;
    INSERT
    INTO PARTIT 
    VALUES
    (
      seq_partit_id.nextval , -- Obtenir PARTIT_ID de la seqncia
      p_DATA_HORA ,
      p_MUNICIPI ,
      p_PAVELLO ,
      p_EQUIP_LOCAL_ID ,
      p_EQUIP_VISITANT_ID ,
      p_COMPETICIO_ID ,
      p_ARBITRE_P_ID ,
      p_L1_ID ,
      p_L2_ID ,
      p_L3_ID ,
      p_L4_ID ,
      p_L5_ID ,
      p_L6_ID ,
      p_L7_ID ,
      p_L8_ID ,
      p_L9_ID ,
      p_L10_ID ,
      p_L11_ID ,
      p_L12_ID ,
      p_V1_ID ,
      p_V2_ID ,
      p_V3_ID ,
      p_V4_ID ,
      p_V5_ID ,
      p_V6_ID ,
      p_V7_ID ,
      p_V8_ID ,
      p_V9_ID ,
      p_V10_ID ,
      p_V11_ID ,
      p_V12_ID ,
      p_ARBITRE_AUX1_ID ,
      p_ARBITRE_AUX2_ID ,
      p_ARBITRE_AUX3_ID
    );
    inserta_log('ABM', 'partit_alta', entrada, RSP, v_inici, systimestamp);
    
    EXCEPTION
    WHEN err_municipi THEN
      DBMS_OUTPUT.PUT_LINE ('El municipi no correspon a lequip local');
      RSP := 'ERROR: El municipi no correspon a lequip local';
      inserta_log('ABM', 'partit_alta', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, 'El municipi no correspon a lequip local');
    WHEN err_pavello then
      DBMS_OUTPUT.PUT_LINE ('El pavell no correspon a lequip local');
      RSP := 'ERROR: El pavell no correspon a lequip local';
      inserta_log('ABM', 'partit_alta', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, 'El pavell no correspon a lequip local');
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('Error: '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'partit_alta', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END partit_alta;


  /** NOM DEL PROCEDIMENT: partit_baixa
      FUNCIONALITAT: Permet donar de baixa un partit 
      PARMETRES D'ENTRADA: PARTIT_ID
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  procedure partit_baixa(
    p_PARTIT_ID         IN PARTIT.PARTIT_ID%type ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  err_partit_no_existeix EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'PARTIT_ID = '||p_PARTIT_ID;
    DELETE
    FROM PARTIT
    WHERE PARTIT_ID = p_PARTIT_ID;
    
    if (sql%rowcount = 0) then
        raise err_partit_no_existeix;
    end if;
    inserta_log('ABM', 'partit_baixa', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     WHEN err_partit_no_existeix THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR El partit no existeix.');
      RSP := 'ERROR El partit no existeix.';
      inserta_log('ABM', 'partit_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('ABM', 'partit_baixa', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END partit_baixa;


  /** NOM DEL PROCEDIMENT: partit_modificacio
      FUNCIONALITAT: Permet modificar un partit 
      PARMETRES D'ENTRADA: Tots els camps de la taula PARTIT
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure partit_modificacio(
    p_PARTIT_ID         IN PARTIT.PARTIT_ID%type ,
    p_DATA_HORA         IN PARTIT.DATA_HORA%type ,
    p_MUNICIPI          IN PARTIT.MUNICIPI%type ,
    p_PAVELLO           IN PARTIT.PAVELLO%type ,
    p_EQUIP_LOCAL_ID    IN PARTIT.EQUIP_LOCAL_ID%type ,
    p_EQUIP_VISITANT_ID IN PARTIT.EQUIP_VISITANT_ID%type ,
    p_COMPETICIO_ID     IN PARTIT.COMPETICIO_ID%type ,
    p_ARBITRE_P_ID      IN PARTIT.ARBITRE_P_ID%type ,
    p_L1_ID             IN PARTIT.L1_ID%type ,
    p_L2_ID             IN PARTIT.L2_ID%type ,
    p_L3_ID             IN PARTIT.L3_ID%type ,
    p_L4_ID             IN PARTIT.L4_ID%type ,
    p_L5_ID             IN PARTIT.L5_ID%type ,
    p_L6_ID             IN PARTIT.L6_ID%type ,
    p_L7_ID             IN PARTIT.L7_ID%type ,
    p_L8_ID             IN PARTIT.L8_ID%type ,
    p_L9_ID             IN PARTIT.L9_ID%type ,
    p_L10_ID            IN PARTIT.L10_ID%type ,
    p_L11_ID            IN PARTIT.L11_ID%type ,
    p_L12_ID            IN PARTIT.L12_ID%type ,
    p_V1_ID             IN PARTIT.V1_ID%type ,
    p_V2_ID             IN PARTIT.V2_ID%type ,
    p_V3_ID             IN PARTIT.V3_ID%type ,
    p_V4_ID             IN PARTIT.V4_ID%type ,
    p_V5_ID             IN PARTIT.V5_ID%type ,
    p_V6_ID             IN PARTIT.V6_ID%type ,
    p_V7_ID             IN PARTIT.V7_ID%type ,
    p_V8_ID             IN PARTIT.V8_ID%type ,
    p_V9_ID             IN PARTIT.V9_ID%type ,
    p_V10_ID            IN PARTIT.V10_ID%type ,
    p_V11_ID            IN PARTIT.V11_ID%type ,
    p_V12_ID            IN PARTIT.V12_ID%type ,
    p_ARBITRE_AUX1_ID   IN PARTIT.ARBITRE_AUX1_ID%type ,
    p_ARBITRE_AUX2_ID   IN PARTIT.ARBITRE_AUX2_ID%type ,
    p_ARBITRE_AUX3_ID   IN PARTIT.ARBITRE_AUX3_ID%type DEFAULT NULL ,
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  err_partit_no_existeix EXCEPTION;
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'PARTIT_ID = '||p_PARTIT_ID||'DATA_HORA = '||p_DATA_HORA||' MUNICIPI = '||p_MUNICIPI||' PAVELLO = '||p_PAVELLO||' EQUIP_LOCAL_ID = '||p_EQUIP_LOCAL_ID||' EQUIP_VISITANT_ID = '||p_EQUIP_VISITANT_ID||' COMPETICIO_ID = '||p_COMPETICIO_ID||' ARBITRE_P_ID = '||p_ARBITRE_P_ID||' L1_ID = '||p_L1_ID||' L2_ID = '||p_L2_ID||' L3_ID = '||p_L3_ID||' L4_ID = '||p_L4_ID||' L5_ID = '||p_L5_ID||' L6_ID = '||p_L6_ID||' L7_ID = '||p_L7_ID||' L8_ID = '||p_L8_ID||' L9_ID = '||p_L9_ID||' L10_ID = '||p_L10_ID||' L11_ID = '||p_L11_ID||' L12_ID = '||p_L12_ID||' V1_ID = '|| p_V1_ID||' V2_ID = '||p_V2_ID||' V3_ID = '||p_V3_ID||' V4_ID = '||p_V4_ID||' V5_ID = '||p_V5_ID||' V6_ID = '||p_V6_ID||' V7_ID = '||p_V7_ID||' V8_ID = '||p_V8_ID||' V9_ID = '||p_V9_ID||' V10_ID = '||p_V10_ID||' V11_ID = '||p_V11_ID||' V12_ID = '||p_V12_ID||' ARBITRE_AUX1_ID = '||p_ARBITRE_AUX1_ID||' ARBITRE_AUX2_ID = '||p_ARBITRE_AUX2_ID||' ARBITRE_AUX3_ID = '||p_ARBITRE_AUX3_ID;
    UPDATE PARTIT
    SET 
      DATA_HORA         = p_DATA_HORA ,
      MUNICIPI          = p_MUNICIPI ,
      PAVELLO           = p_PAVELLO ,
      EQUIP_LOCAL_ID    = p_EQUIP_LOCAL_ID ,
      EQUIP_VISITANT_ID = p_EQUIP_VISITANT_ID ,
      COMPETICIO_ID     = p_COMPETICIO_ID ,
      ARBITRE_P_ID      = p_ARBITRE_P_ID ,
      L1_ID             = p_L1_ID ,
      L2_ID             = p_L2_ID ,
      L3_ID             = p_L3_ID ,
      L4_ID             = p_L4_ID ,
      L5_ID             = p_L5_ID ,
      L6_ID             = p_L6_ID ,
      L7_ID             = p_L7_ID ,
      L8_ID             = p_L8_ID ,
      L9_ID             = p_L9_ID ,
      L10_ID            = p_L10_ID ,
      L11_ID            = p_L11_ID ,
      L12_ID            = p_L12_ID ,
      V1_ID             = p_V1_ID ,
      V2_ID             = p_V2_ID ,
      V3_ID             = p_V3_ID ,
      V4_ID             = p_V4_ID ,
      V5_ID             = p_V5_ID ,
      V6_ID             = p_V6_ID ,
      V7_ID             = p_V7_ID ,
      V8_ID             = p_V8_ID ,
      V9_ID             = p_V9_ID ,
      V10_ID            = p_V10_ID ,
      V11_ID            = p_V11_ID ,
      V12_ID            = p_V12_ID ,
      ARBITRE_AUX1_ID   = p_ARBITRE_AUX1_ID ,
      ARBITRE_AUX2_ID   = p_ARBITRE_AUX2_ID ,
      ARBITRE_AUX3_ID   = p_ARBITRE_AUX3_ID
    WHERE PARTIT_ID     = p_PARTIT_ID;
    
    if (sql%rowcount = 0) then
        raise err_partit_no_existeix;
    end if;
    inserta_log('ABM', 'partit_modificacio', entrada, RSP, v_inici, systimestamp);
  
    EXCEPTION
     WHEN err_partit_no_existeix THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR El partit no existeix.');
      RSP := 'ERROR El partit no existeix.';
      inserta_log('ABM', 'partit_modificacio', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
     WHEN OTHERS THEN
       DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
       RSP := 'ERROR '||sqlerrm;
       inserta_log('ABM', 'partit_modificacio', entrada, rsp, v_inici, systimestamp);
       -- raise_application_error (-20001, SQLERRM);
  END partit_modificacio;


  /** NOM DEL PROCEDIMENT: inserta_log
      FUNCIONALITAT: Permet fer un registre dels procediments cridats, els parmetres d'entrada i els de sortida
      PARMETRES D'ENTRADA: paquet del procediment que crida al log
                            procediment que crida al log
                            entrada: parmetres d'entrada al procediment que crida al log
                            sortida: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
                            inici: moment en que comena el procediment que crida al log
                            final: moment en que acaba el procediment que crida al log
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure inserta_log(
    p_paquet IN varchar2, 
    p_procediment IN varchar2, 
    p_entrada IN varchar2, 
    p_sortida IN varchar2, 
    p_inici IN timestamp, 
    p_final IN timestamp) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    INSERT INTO LOG_CRIDES VALUES (seq_log_crides_id.nextval, p_paquet, p_procediment, p_entrada, p_sortida, p_inici, p_final);
    
    EXCEPTION
      when others then
        raise_application_error (-20001, SQLERRM);
  END inserta_log;
END ABM;

/
--------------------------------------------------------
--  DDL for Package Body CONSULTES
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "SYSTEM"."CONSULTES" AS
/**	
    NOM DEL PAQUET: CONSULTES
    FUNCIONALITAT: Proporciona les operaciones necessries per fer les consultes.
**/


  /** NOM DEL PROCEDIMENT: jugadors_competicio
      FUNCIONALITAT: Retorna el llistat de tots els jugadors duna competici donada amb totes les seves dades, incloent la data de finalitzaci de contracte actual.
      PARMETRES D'ENTRADA: competicio_id
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --(Consulta a) El llistat de tots els jugadors duna competici donada amb totes les seves dades, incloent la data de finalitzaci del contracte actual.
  procedure jugadors_competicio(
    p_competicio_id IN COMPETICIO.COMPETICIO_ID%type, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'competicio_id = '||p_competicio_id;
    OPEN p_cursor FOR
      SELECT j.*, c.data_final_contracte --, TO_CHAR(c.data_signatura,'DD')+ '/' + TO_CHAR(c.data_signatura,'MM') + '/' + (TO_NUMBER(c.data_signatura,'yyyy') + c.durada_contracte) "DATA_FINAL_CONTRACTE"
      FROM jugador j, estadistiques_P_J e, partit p, contracte c 
      WHERE p.competicio_id = p_competicio_id   -- partits jugats d'una competici
        AND e.partit_id = p.partit_id -- estadstiques dels partits (de la competici)
        AND j.jugador_id = e.jugador_id -- jugadors de les estadstiques (dels partits de la competici)
        AND c.jugador_id = j.jugador_id -- contracte del jugador
        AND c.ultim = 1; -- del contracte actual
    
    inserta_log('CONSULTES', 'jugadors_competicio', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('CONSULTES', 'jugadors_competicio', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END jugadors_competicio;


  /** NOM DEL PROCEDIMENT: equips_competicio
      FUNCIONALITAT: Retorna el llistat de tots els equips d'una competici ordenats pel nombre de punts totals a favor en la temporada actual.
      PARMETRES D'ENTRADA: competicio_id
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  --(Consulta b) El llistat de tots els equips d'una competici ordenats pel nombre de punts totals a favor en la temporada actual.
  procedure equips_competicio(
    p_competicio_id IN COMPETICIO.COMPETICIO_ID%type, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'competicio_id = '||p_competicio_id;
    OPEN p_cursor FOR
      SELECT c.competicio, e.equip, sum(epj.pt) "punts_a_favor"
      FROM competicio c, equip e, partit p, estadistiques_p_j epj, temporada t
      WHERE c.temporada_id = t.temporada_id
        AND t.temporada_actual = 1  -- competicins de la temporada actual
        AND c.competicio_id = p.competicio_id -- partits de les competicions
        AND p.partit_id = epj.partit_id -- estadstiques dels partits
      GROUP BY c.competicio, e.equip
      ORDER BY 3;
    
    inserta_log('CONSULTES', 'equips_competicio', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('CONSULTES', 'equips_competicio', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);      
  END equips_competicio;


  /** NOM DEL PROCEDIMENT: ll_5_millors_jugadors
      FUNCIONALITAT: Retorna el llistat dels 5 millors jugadors per posici en funci de la seva valoraci.
      PARMETRES D'ENTRADA: ambit_id, genere_id i modalitat_id
      PARMETRES DE SORTIDA: cursor_base, cont el llistat dels 5 millors jugadors de la posici base.
                             cursor_escorta, cont el llistat dels 5 millors jugadors de la posici escorta.
                             cursor_aler, cont el llistat dels 5 millors jugadors de la posici aler.
                             cursor_aler_pivot, cont el llistat dels 5 millors jugadors de la posici aler_pivot.
                             cursor_pivot, cont el llistat dels 5 millors jugadors de la posici pivot.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  --(Consulta c) Donats un mbit, un gnere i una modalitat de competici, el llistat dels 5 millors jugadors per posici en funci de la seva valoraci.
  PROCEDURE ll_5_millors_jugadors(
    p_ambit_id IN AMBIT.AMBIT_ID%type, 
    p_genere_id IN GENERE.GENERE_ID%type, 
    p_modalitat_id IN MODALITAT.MODALITAT_ID%type, 
    p_cursor_base OUT SYS_REFCURSOR, 
    p_cursor_escorta OUT SYS_REFCURSOR, 
    p_cursor_aler OUT SYS_REFCURSOR, 
    p_cursor_aler_pivot OUT SYS_REFCURSOR, 
    p_cursor_pivot OUT SYS_REFCURSOR, 
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'ambit_id = '||p_ambit_id||' genere_id = '||p_genere_id||' modalitat_id = '||p_modalitat_id;
    OPEN p_cursor_base FOR
    SELECT j.posicio_id "pos_id", (Select p1.posicio From Posicio p1 Where p1.posicio_id = j.posicio_id AND rownum <= 1) "pos", j.nom "nom", sum(epj.v) "valoracio"
      FROM jugador j, estadistiques_p_j epj, partit p, competicio c
      WHERE j.jugador_id = epj.jugador_id -- estadstiques dels jugadors
        AND epj.partit_id = p.partit_id -- partits de les estadstiques
        AND p.competicio_id = c.competicio_id -- competicions dels partits
        AND c.ambit_id = 1  -- mbit de la competici
        AND c.genere_id = 1 -- gnere de la competici
        AND c.modalitat_id = 1  -- modalitat de la competici
        AND j.posicio_id = 1 -- posici base
        AND rownum <= 5
      GROUP BY posicio_id, nom  -- per posici
      ORDER BY 4 desc;
      
    OPEN p_cursor_escorta FOR
    SELECT j.posicio_id AS pos_id, (Select p1.posicio From Posicio p1 Where p1.posicio_id = j.posicio_id) AS pos, j.nom AS nom, sum(epj.v) AS valoracio
      --into t_c_2
      FROM jugador j, estadistiques_p_j epj, partit p, competicio c
      WHERE j.jugador_id = epj.jugador_id -- estadstiques dels jugadors
        AND epj.partit_id = p.partit_id -- partits de les estadstiques
        AND p.competicio_id = c.competicio_id -- competicions dels partits
        AND c.ambit_id = 1  -- mbit de la competici
        AND c.genere_id = 1 -- gnere de la competici
        AND c.modalitat_id = 1  -- modalitat de la competici
        AND j.posicio_id = 2 -- posici escorta
        AND rownum <= 5
      GROUP BY posicio_id, nom  -- per posici
      ORDER BY 4 desc;
      
    OPEN p_cursor_aler FOR
    SELECT j.posicio_id AS pos_id, (Select p1.posicio From Posicio p1 Where p1.posicio_id = j.posicio_id) AS pos, j.nom AS nom, sum(epj.v) AS valoracio
      FROM jugador j, estadistiques_p_j epj, partit p, competicio c
      WHERE j.jugador_id = epj.jugador_id -- estadstiques dels jugadors
        AND epj.partit_id = p.partit_id -- partits de les estadstiques
        AND p.competicio_id = c.competicio_id -- competicions dels partits
        AND c.ambit_id = 1  -- mbit de la competici
        AND c.genere_id = 1 -- gnere de la competici
        AND c.modalitat_id = 1  -- modalitat de la competici
        AND j.posicio_id = 3 -- posici escorta
        AND rownum <= 5
      GROUP BY posicio_id, nom  -- per posici
      ORDER BY 4 desc;
      
    OPEN p_cursor_aler_pivot FOR
    SELECT j.posicio_id AS pos_id, (Select p1.posicio From Posicio p1 Where p1.posicio_id = j.posicio_id) AS pos, j.nom AS nom, sum(epj.v) AS valoracio
      FROM jugador j, estadistiques_p_j epj, partit p, competicio c
      WHERE j.jugador_id = epj.jugador_id -- estadstiques dels jugadors
        AND epj.partit_id = p.partit_id -- partits de les estadstiques
        AND p.competicio_id = c.competicio_id -- competicions dels partits
        AND c.ambit_id = 1  -- mbit de la competici
        AND c.genere_id = 1 -- gnere de la competici
        AND c.modalitat_id = 1  -- modalitat de la competici
        AND j.posicio_id = 4 -- posici escorta
        AND rownum <= 5
      GROUP BY posicio_id, nom  -- per posici
      ORDER BY 4 desc;
      
    OPEN p_cursor_pivot FOR
    SELECT j.posicio_id AS pos_id, (Select p1.posicio From Posicio p1 Where p1.posicio_id = j.posicio_id) AS pos, j.nom AS nom, sum(epj.v) AS valoracio
      FROM jugador j, estadistiques_p_j epj, partit p, competicio c
      WHERE j.jugador_id = epj.jugador_id -- estadstiques dels jugadors
        AND epj.partit_id = p.partit_id -- partits de les estadstiques
        AND p.competicio_id = c.competicio_id -- competicions dels partits
        AND c.ambit_id = 1  -- mbit de la competici
        AND c.genere_id = 1 -- gnere de la competici
        AND c.modalitat_id = 1  -- modalitat de la competici
        AND j.posicio_id = 5 -- posici escorta
        AND rownum <= 5
      GROUP BY posicio_id, nom  -- per posici
      ORDER BY 4 desc;

    inserta_log('CONSULTES', 'll_5_millors_jugadors', entrada, RSP, v_inici, systimestamp);

  EXCEPTION
      WHEN OTHERS THEN
        DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
        RSP := 'ERROR '||sqlerrm;
        inserta_log('CONSULTES', 'll_5_millors_jugadors', entrada, RSP, v_inici, systimestamp);
        -- raise_application_error (-20001, SQLERRM);
  END ll_5_millors_jugadors;


  /** NOM DEL PROCEDIMENT: contractes_any
      FUNCIONALITAT: Retorna el nmero de contractes de jugadors signats i el valor econmic total de cadascun d'ells.
      PARMETRES D'ENTRADA: any i representant_id
      PARMETRES DE SORTIDA: n, nmero de contractes de jugadors signats
                             cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  --(Consulta d) Donat un any i un representant de jugadors, el nmero de contractes de jugadors signats i el valor econmic total de cadascun d'ells.
  procedure contractes_any(
    p_any number, 
    p_representant_id IN REPRESENTANT.REPRESENTANT_ID%type, 
    p_n OUT number, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'any = '||p_any||' representant_id = '||p_representant_id;
    SELECT COUNT(contracte_id) INTO p_n FROM contracte WHERE TO_NUMBER(TO_CHAR(data_signatura, 'yyyy')) = p_any AND representant_id = p_representant_id;
    OPEN p_cursor FOR
      SELECT c.representant_id, r.representant, c.contracte_id, c.valor_operacio
      FROM contracte c, representant r
      WHERE TO_NUMBER(TO_CHAR(c.data_signatura, 'yyyy')) = p_any 
        AND c.representant_id = p_representant_id
        AND c.representant_id = r.representant_id;
      
      inserta_log('CONSULTES', 'contractes_any', entrada, RSP, v_inici, systimestamp);
  
    EXCEPTION
      WHEN OTHERS THEN
        DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
        RSP := 'ERROR '||sqlerrm;
        inserta_log('CONSULTES', 'contractes_any', entrada, RSP, v_inici, systimestamp);
        -- raise_application_error (-20001, SQLERRM);
  END contractes_any;  


  /** NOM DEL PROCEDIMENT: ll_10_equips_major_gast
      FUNCIONALITAT: Retorna el llistat dels 10 equips que ms diners shan gastat en adquisici de jugadors, ordenat de ms a menys.
      PARMETRES D'ENTRADA: any
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  --(Consulta e) Donat un any concret el llistat dels 10 equips que ms diners shan gastat en adquisici de jugadors, ordenat de ms a menys.
  procedure ll_10_equips_major_gast(
    p_any IN number, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2) AS
  v_inici timestamp;
  entrada varchar2(500);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'any = '||p_any;
    open p_cursor for
      SELECT e.equip, sum(c.valor_operacio)
      FROM equip e, contracte c
      WHERE c.equip_comprador_id = e.equip_id AND TO_NUMBER(TO_CHAR(c.data_signatura, 'yyyy')) = p_any 
        and rownum <= 10
      group by e.equip
      ORDER BY sum(c.valor_operacio) desc;    
    
    inserta_log('CONSULTES', 'll_10_equips_major_gast', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('CONSULTES', 'll_10_equips_major_gast', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END ll_10_equips_major_gast;


  /** NOM DEL PROCEDIMENT: ll_jugadors_estaran_lliures
      FUNCIONALITAT: Retorna el llistat de jugadors que acaben contracte a final de la present temporada o que estan en actiu per sense equip.
      PARMETRES D'ENTRADA: pais_id, genere_id i modalitat_id
      PARMETRES DE SORTIDA: cursor que cont el llistat demanat per la funcionalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/    
  --(Consulta f) Donat un pas, un gnere i una modalitat, el llistat de jugadors que acaben contracte a final de la present temporada o que estan en actiu per sense equip.
  procedure ll_jugadors_estaran_lliures(
    p_pais_id IN PAIS.PAIS_ID%type, 
    p_genere_id IN GENERE.GENERE_ID%type, 
    p_modalitat_id IN MODALITAT.MODALITAT_ID%type, 
    p_cursor OUT SYS_REFCURSOR, 
    RSP OUT varchar2) AS
  data_actual date;
  anny number;
  mes number;
  v_inici timestamp;
  entrada varchar2(500);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'pais_id = '||p_pais_id||' genere_id = '||p_genere_id||' modalitat_id = '||p_modalitat_id;
    SELECT SYSDATE INTO data_actual FROM DUAL;  -- data actual
    SELECT TO_NUMBER(TO_CHAR(SYSDATE,'yyyy')) INTO anny FROM DUAL;  -- any actual
    SELECT TO_NUMBER(TO_CHAR(SYSDATE,'mm')) INTO mes FROM DUAL; -- mes actual
    IF (mes >= 7 ) then anny := anny + 1; END IF;  -- any del final de la present temporada (temporada fins 30/6)
    
    open p_cursor for
      SELECT distinct j.jugador_id, j.nom
      FROM jugador j, contracte c
      WHERE j.federacio_id = p_pais_id -- jugadors del pas
        AND j.genere_id = p_genere_id  -- jugadors del gnere
        AND j.modalitat_id = p_modalitat_id --jugadors de la modalitat   
        AND (
              (
                TO_NUMBER(TO_CHAR(c.data_final_contracte,'yyyy')) = anny --que acaben contracte a final de la present temporada
                AND j.jugador_id = c.jugador_id -- contractes dels jugadors
                AND c.ultim = 1  -- contracte actual
              )
              OR 
              (
                j.activitat_id = 1 -- est en actiu        -- que estan en actiu per sense equip
                AND j.jugador_id = c.jugador_id -- contractes dels jugadors
                AND c.ultim = 1 -- el contracte s l'ltim
                AND c.data_final_contracte < data_actual -- est sense equip
              )
              OR  -- no han tingut cap contracte
              (
                j.jugador_id NOT IN (SELECT jugador_id FROM contracte)
              )
            )
        ;    
    
    inserta_log('CONSULTES', 'll_jugadors_estaran_lliures', entrada, RSP, v_inici, systimestamp);
  
  EXCEPTION
     WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('CONSULTES', 'll_jugadors_estaran_lliures', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END ll_jugadors_estaran_lliures;


  /** NOM DEL PROCEDIMENT: inserta_log
      FUNCIONALITAT: Permet fer un registre dels procediments cridats, els parmetres d'entrada i els de sortida
      PARMETRES D'ENTRADA: paquet del procediment que crida al log
                            procediment que crida al log
                            entrada: parmetres d'entrada al procediment que crida al log
                            sortida: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
                            inici: moment en que comena el procediment que crida al log
                            final: moment en que acaba el procediment que crida al log
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  procedure inserta_log(
    p_paquet IN varchar2, 
    p_procediment IN varchar2, 
    p_entrada IN varchar2, 
    p_sortida IN varchar2, 
    p_inici IN timestamp, 
    p_final IN timestamp) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    INSERT INTO LOG_CRIDES VALUES (seq_log_crides_id.nextval, p_paquet, p_procediment, p_entrada, p_sortida, p_inici, p_final);
    
    EXCEPTION
      WHEN OTHERS THEN
        raise_application_error (-20001, SQLERRM);
  END inserta_log;
END CONSULTES;

/
--------------------------------------------------------
--  DDL for Package Body MODUL_ESTADISTIC
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "SYSTEM"."MODUL_ESTADISTIC" AS
/**	
    NOM DEL PAQUET: MODUL_ESTADISTIC
    FUNCIONALITAT: Proporciona les operaciones necessries per fer les consultes i les actualitzacions del mdul estadstic.
**/


  /** NOM DEL PROCEDIMENT: n_total_jugadors_en_actiu
      FUNCIONALITAT: Retorna el nmero total de jugadors en actiu en tots els gneres i modalitats.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: n, el nmero total de jugadors en actiu en tots els gneres i modalitats.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --Consulta 1. El nmero total de jugadors en actiu en tots els gneres i modalitats.
  procedure n_total_jugadors_en_actiu(
    p_n OUT m_e_c1.jugadors_actius%type, 
    RSP OUT varchar2) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN   
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := '';
    Select jugadors_actius Into p_n From M_E_C1;

    inserta_log('MODUL_ESTADISTIC', 'n_total_jugadors_en_actiu', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'n_total_jugadors_en_actiu', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END n_total_jugadors_en_actiu;


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C1
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades de nmero total de jugadors en actiu en tots els gneres i modalitats.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/   
  procedure actualitza_M_E_C1 AS
  v_inici timestamp;
  entrada varchar2(500);
  RSP varchar2(200);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := '';
    -- S'actualitza: after insert or update of estat_id on jugador
    Update M_E_C1 Set jugadors_actius = (Select count(jugador_id) From jugador Where activitat_id = 1);
    
    inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C1', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C1', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  end actualitza_m_e_c1;


  /** NOM DEL PROCEDIMENT: maxim_anotador
      FUNCIONALITAT: Retorna, donada una competici, el seu mxim anotador en la temporada en curs (o b la darrera temporada, si ens trobem en el perode entre temporades).
      PARMETRES D'ENTRADA: competicio_id
      PARMETRES DE SORTIDA: competicio, temporada, jugador_id, nom (del jugador).
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  --Consulta 2. Donada una competici, el seu mxim anotador en la temporada en curs (o b la darrera temporada, si ens trobem en el perode entre temporades).
  procedure maxim_anotador(
    p_competicio_id IN competicio.competicio_id%type, 
    p_competicio OUT COMPETICIO.COMPETICIO%type, 
    p_temporada OUT temporada.temporada%type, 
    p_jugador_id OUT JUGADOR.JUGADOR_ID%type, 
    p_nom OUT JUGADOR.NOM%type, 
    RSP OUT varchar2) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'competicio_id = '||p_competicio_id;
    Select competicio, temporada, jugador_id, jugador Into p_competicio, p_temporada, p_jugador_id, p_nom From M_E_C2 Where competicio_id = p_competicio_id;
    
    inserta_log('MODUL_ESTADISTIC', 'maxim_anotado', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'maxim_anotado', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  end maxim_anotador;


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C2
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades de mxim anotador en la temporada en curs (o b la darrera temporada, si ens trobem en el perode entre temporades) donada una competici.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/ 
  procedure actualitza_m_e_c2(p_competicio_id in competicio.competicio_id%type) as
    comp competicio.competicio%type;
    temp temporada.temporada%type;
    j_id jugador.jugador_id%type;
    jug jugador.nom%type;
    punts estadistiques_p_j.pt%type;
    contador number;
  v_inici timestamp; 
  entrada varchar2(500);
  RSP varchar2(200);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'competicio_id = '||p_competicio_id;
    -- S'actualitza: after insert or update on estadistiques_p_j, partit, competicio, temporada 
    -- Jugador que ms ha anotat
    Select co.competicio, t.temporada, j.jugador_id, j.nom , max(sum(pt)) Into comp, temp, j_id, jug, punts From estadistiques_p_j es, partit p, competicio co, jugador j, temporada t Where 
      co.competicio_id = p_competicio_id
      And co.temporada_id = t.temporada_id
      And t.temporada_actual = 1 -- de la temporada actual o darrera
      and p.competicio_id = co.competicio_id -- els partits de la competicio
      and p.partit_id = es.estadistica_id; -- les estadstiques dels partits
      -- Group by co.competicio, t.temporada, j.jugador_id, j.nom;
      
    Select count(competicio_id) Into contador From m_e_c2 Where 
      competicio_id = p_competicio_id;
    if (contador = 0) Then
      INSERT INTO m_e_c2 (competicio_id, competicio, temporada, jugador_id, jugador, punts) 
      VALUES (p_competicio_id, comp, temp, j_id, jug, punts);
    else
      Update M_E_C2 Set 
        competicio = comp,
        temporada = temp,
        jugador_id = j_id,
        jugador = jug,
        punts = punts
      Where competicio_id = p_competicio_id;
    end if;
    
    inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C2', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C2', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  end actualitza_m_e_c2;
  

  /** NOM DEL PROCEDIMENT: jugador_mes_ben_pagat
      FUNCIONALITAT: Retorna el jugador ms ben pagat de cada modalitat i gnere.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: Identificador del jugador, nom i salari brut anual per a cada una de les modalitats i gneres.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/   
  --Consulta 3. El jugador ms ben pagat de cada modalitat i gnere.
  --procedure jugador_mes_ben_pagat(p_cursor OUT SYS_REFCURSOR, RSP OUT varchar2) AS
  procedure jugador_mes_ben_pagat(
    p_j_m1_g1 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m1_g1 OUT JUGADOR.NOM%type, p_s_m1_g1 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
    p_j_m1_g2 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m1_g2 OUT JUGADOR.NOM%type, p_s_m1_g2 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
    p_j_m2_g1 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m2_g1 OUT JUGADOR.NOM%type, p_s_m2_g1 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
    p_j_m2_g2 OUT JUGADOR.JUGADOR_ID%type, p_j_n_m2_g2 OUT JUGADOR.NOM%type, p_s_m2_g2 OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
    RSP OUT varchar2) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := '';
    Select j_m1_g1, j_n_m1_g1, s_m1_g1, 
           j_m1_g2, j_n_m1_g2, s_m1_g2, 
           j_m2_g1, j_n_m2_g1, s_m2_g1, 
           j_m2_g2, j_n_m2_g2, s_m2_g2 Into 
           p_j_m1_g1, p_j_n_m1_g1, p_s_m1_g1, 
           p_j_m1_g2, p_j_n_m1_g2, p_s_m1_g2, 
           p_j_m2_g1, p_j_n_m2_g1, p_s_m2_g1, 
           p_j_m2_g2, p_j_n_m2_g2, p_s_m2_g2 From M_E_C3;
           
    inserta_log('MODUL_ESTADISTIC', 'jugador_mes_ben_pagat', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'jugador_mes_ben_pagat', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END jugador_mes_ben_pagat;



  /** NOM DEL PROCEDIMENT: actualitza_M_E_C3
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del jugador ms ben pagat de cada modalitat i gnere.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/ 
  procedure actualitza_m_e_c3 as
    salari_1_1 contracte.salari_brut_anual%type;
    j_id_1_1 jugador.jugador_id%type;
    j_n_1_1 jugador.nom%type;
    salari_1_2 contracte.salari_brut_anual%type;
    j_id_1_2 jugador.jugador_id%type;
    j_n_1_2 jugador.nom%type;
    salari_2_1 contracte.salari_brut_anual%type;
    j_id_2_1 jugador.jugador_id%type;
    j_n_2_1 jugador.nom%type;
    salari_2_2 contracte.salari_brut_anual%type;
    j_id_2_2 jugador.jugador_id%type;
    j_n_2_2 jugador.nom%type;
  v_inici timestamp; 
  entrada varchar2(500); 
  RSP varchar2(200);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := '';
    -- S'actualitza: after insert or update on contracte, jugador
    -- Modalitat Normal (1), gnere Mascul (1)
    Select j.jugador_id, j.nom, max(c.salari_brut_anual) "a" Into j_id_1_1, j_n_1_1, salari_1_1  From contracte c, jugador j Where 
      c.jugador_id = j.jugador_id
      And j.modalitat_id = 1
      and j.genere_id = 1
      group by j.jugador_id, j.nom;
    -- Modalitat Normal (1), gnere Femen (2)
    Select j.jugador_id, j.nom, max(c.salari_brut_anual) "a" Into j_id_1_2, j_n_1_2, salari_1_2  From contracte c, jugador j Where 
      c.jugador_id = j.jugador_id
      And j.modalitat_id = 1
      and j.genere_id = 2
      group by j.jugador_id, j.nom;
    -- Modalitat Cadira de rodes (2), gnere Mascul (1)
    Select j.jugador_id, j.nom, max(c.salari_brut_anual) "a" Into j_id_2_1, j_n_2_1, salari_2_1  From contracte c, jugador j Where 
      c.jugador_id = j.jugador_id
      And j.modalitat_id = 2
      and j.genere_id = 1
      group by j.jugador_id, j.nom;
    -- Modalitat Cadira de rodes (2), gnere Femen (2)
    Select j.jugador_id, j.nom, max(c.salari_brut_anual) "a" Into j_id_2_2, j_n_2_2, salari_2_2  From contracte c, jugador j Where 
      c.jugador_id = j.jugador_id
      and j.modalitat_id = 2
      and j.genere_id = 2
      group by j.jugador_id, j.nom;
        
    Update M_E_C3 Set 
      j_m1_g1 = j_id_1_1, 
      j_n_m1_g1 = j_n_1_1,
      s_m1_g1 = salari_1_1, 
      j_m1_g2 = j_id_1_2,
      j_n_m1_g2 = j_n_1_2,
      s_m1_g2 = salari_1_2, 
      j_m2_g1 = j_id_2_1, 
      j_n_m2_g1 = j_n_2_1,
      s_m2_g1 = salari_2_1, 
      j_m2_g2 = j_id_2_2,
      j_n_m2_g2 = j_n_2_2,
      s_m2_g2 = salari_2_2;
      
    inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C3', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C3', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  end actualitza_m_e_c3;
  
  
  /** NOM DEL PROCEDIMENT: jugador_mes_guanys_acumulats
      FUNCIONALITAT: Retorna el jugador amb ms guanys acumulats al llarg de tota la seva carrera esportiva
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: jugador_id, identificador del jugador.
                             nom, nom del jugador.
                             guanys, guans acumulats del jugador.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/ 
  --Consulta 4. El jugador amb ms guanys acumulats al llarg de tota la seva carrera esportiva.
  procedure jugador_mes_guanys_acumulats(
    p_jugador_id OUT JUGADOR.JUGADOR_ID%type, 
    p_nom OUT JUGADOR.NOM%type, 
    p_guanys OUT CONTRACTE.VALOR_OPERACIO%type, 
    RSP OUT varchar2) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := '';
    Select jugador_id, nom, guanys Into p_jugador_id, p_nom, p_guanys From M_E_C4;
    
    inserta_log('MODUL_ESTADISTIC', 'jugador_mes_guanys_acumulats', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'jugador_mes_guanys_acumulats', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  end jugador_mes_guanys_acumulats;


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C4
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del jugador amb ms guanys acumulats al llarg de tota la seva carrera esportiva.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: 
  **/
  procedure actualitza_M_E_C4 AS
    j_id jugador.jugador_id%type;
    nom jugador.nom%type;
    guanys contracte.salari_brut_anual%type;
  v_inici timestamp; 
  entrada varchar2(500); 
  RSP varchar2(200);
  BEGIN
  v_inici := systimestamp;
  RSP := 'OK';
  entrada := '';
    -- S'actualitza: after insert or update on contracte, jugador
    Select j.jugador_id, j.nom, max(sum(c.salari_brut_anual)) Into j_id, nom, guanys From contracte c, jugador j Where 
      c.jugador_id = j.jugador_id
      -- And rownum = 1 -- per treure max()
      group by j.jugador_id, j.nom
      -- order by 3  -- per treure max()
      ;
    
    Update M_E_C4 Set
      jugador_id = j_id, 
      nom = nom, 
      guanys = guanys;
      
    inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C4', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C4', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END actualitza_M_E_C4;
  
  
  /** NOM DEL PROCEDIMENT: sou_mig_anual
      FUNCIONALITAT: Retorna el sou mig anual dels jugadors donat un pas, una temporada, un gnere i una modalitat.
      PARMETRES D'ENTRADA: federacio_id, identificador de la federaci del jugador (pas al que ha jugat).
                            temporada_id, identificador de la temporada.
                            genere_id, identificador del gnere del jugador.
                            modalitat_id, identificador de la modalitat del jugador.
      PARMETRES DE SORTIDA: sou_mig_anual, sou mig anual dels jugadors donat un pas, una temporada, un gnere i una modalitat.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --Consulta 5. Donat un pas, una temporada, un gnere i una modalitat, el sou mig anual dels jugadors.
  procedure sou_mig_anual( 
    p_federacio_id IN JUGADOR.FEDERACIO_ID%type, 
    p_temporada_id IN TEMPORADA.TEMPORADA_ID%type, 
    p_genere_id IN JUGADOR.GENERE_ID%type, 
    p_modalitat_id IN JUGADOR.MODALITAT_ID%type, 
    p_sou_mig_anual OUT CONTRACTE.SALARI_BRUT_ANUAL%type, 
    RSP OUT varchar2) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'federacio_id = '||p_federacio_id||' temporada_id = '||p_temporada_id||' genere_id = '||p_genere_id||' modalitat_id = '||p_modalitat_id;
    Select sou_mig_anual Into p_sou_mig_anual From M_E_C5 Where 
      pais_id = p_federacio_id 
      And temporada_id = p_temporada_id 
      And genere_id = p_genere_id 
      And modalitat_id = p_modalitat_id;
      
    inserta_log('MODUL_ESTADISTIC', 'sou_mig_anual', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'sou_mig_anual', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END sou_mig_anual;


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C5
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del sou mig anual dels jugadors donat un pas, una temporada, un gnere i una modalitat.
      PARMETRES D'ENTRADA: federacio_id, identificador de la federaci del jugador (pas al que ha jugat).
                            temporada_id, identificador de la temporada.
                            genere_id, identificador del gnere del jugador.
                            modalitat_id, identificador de la modalitat del jugador.
      PARMETRES DE SORTIDA: 
  **/
  procedure actualitza_m_e_c5(
    p_federacio_id IN JUGADOR.FEDERACIO_ID%type, 
    p_temporada_id IN TEMPORADA.TEMPORADA_ID%type, 
    p_genere_id IN JUGADOR.GENERE_ID%type, 
    p_modalitat_id IN JUGADOR.MODALITAT_ID%type) AS
  s_m CONTRACTE.SALARI_BRUT_ANUAL%type;
  contador number;
  v_inici timestamp; 
  entrada varchar2(500); 
  RSP varchar2(200);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'federacio_id = '||p_federacio_id||' temporada_id = '||p_temporada_id||' genere_id = '||p_genere_id||' modalitat_id = '||p_modalitat_id;
    -- S'actualitza: after insert or update on contracte, equip, contracte_temporada
    -- pais_id, temporada, genere_id, modalitat_id
    Select (sum(c.salari_brut_anual))/(count(c.contracte_id)) Into s_m From contracte c, jugador j, equip e, contracte_temporada ct Where
      e.pais_id = p_federacio_id
      And c.equip_comprador_id = e.pais_id -- contractes del pas
      And c.jugador_id = j.jugador_id -- jugadors dels contractes
      And j.genere_id = p_genere_id 
      And j.modalitat_id = p_modalitat_id 
      And c.contracte_id = ct.contracte_id -- temporades dels contractes
      And ct.temporada_id = p_temporada_id;
    
    Select count(pais_id) Into contador From m_e_c5 Where 
      pais_id = p_federacio_id And temporada_id = p_temporada_id And genere_id = p_genere_id And modalitat_id = p_modalitat_id;
    if (contador = 0) Then
      INSERT INTO m_e_c5 (pais_id, temporada_id, genere_id, modalitat_id, sou_mig_anual) 
        VALUES (p_federacio_id, p_temporada_id, p_genere_id, p_modalitat_id, s_m);
    else
      Update M_E_C5 Set sou_mig_anual = s_m Where 
        pais_id = p_federacio_id 
        And temporada_id = p_temporada_id 
        And genere_id = p_genere_id 
        And modalitat_id = p_modalitat_id;
    end if;
    
    inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C5', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C5', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END actualitza_M_E_C5;
  
  
  /** NOM DEL PROCEDIMENT: millors_equips
      FUNCIONALITAT: Retorna els millors equips ofensius i defensius donada una competici i una temporada.
      PARMETRES D'ENTRADA: competicio_id, identificador de la competici.
                            temporada_id, identificador de la temporada.
      PARMETRES DE SORTIDA: competicio, nom de la competici.
                             millor_ofensiu_id, Identificador del millor equip ofensiu. 
                             millor_ofensiu_nom, nom del millor equip ofensiu.
                             millor_defensiu_id, Identificador del millor equip defensiu.
                             millor_defensiu_nom, nom del millor equip defensiu.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --Consulta 6. Donada una competici i una temporada, els millors equips ofensius i defensius.
  procedure millors_equips(
    p_competicio_id in competicio.competicio_id%type, 
    p_temporada_id IN TEMPORADA.TEMPORADA_ID%type, 
    p_competicio OUT COMPETICIO.COMPETICIO%type, 
    p_millor_ofensiu_id OUT EQUIP.EQUIP_ID%type, 
    p_millor_ofensiu_nom OUT EQUIP.EQUIP%type, 
    p_millor_defensiu_id OUT EQUIP.EQUIP_ID%type, 
    p_millor_defensiu_nom OUT EQUIP.EQUIP%type, 
    RSP OUT varchar2) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'competicio_id = '||p_competicio_id||' temporada_id = '||p_temporada_id;
    Select competicio, millor_ofensiu_id, p_millor_ofensiu_nom, p_millor_defensiu_id, p_millor_defensiu_nom Into p_competicio, p_millor_ofensiu_id, p_millor_ofensiu_nom, p_millor_defensiu_id, p_millor_defensiu_nom From M_E_C6 Where competicio_id = p_competicio_id And temporada = p_temporada_id;
    
    inserta_log('MODUL_ESTADISTIC', 'millors_equips', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'millors_equips', entrada, rsp, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END millors_equips;


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C6
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades dels millors equips ofensius i defensius donada una competici i una temporada.
      PARMETRES D'ENTRADA: competicio_id, identificador de la competici.
                            temporada_id, identificador de la temporada.
      PARMETRES DE SORTIDA: 
  **/
  procedure actualitza_m_e_c6(
    p_competicio_id IN COMPETICIO.COMPETICIO_ID%type, 
    p_temporada_id IN TEMPORADA.TEMPORADA_ID%type) AS
    compet COMPETICIO.COMPETICIO%type;
    temp TEMPORADA.TEMPORADA%type;
    millor_o_id EQUIP.EQUIP_ID%type;
    millor_o EQUIP.EQUIP%type;
    millor_d_id EQUIP.EQUIP_ID%type;
    millor_d EQUIP.EQUIP_ID%type;
    n estadistiques_p_j.ro%type;
    contador number;
  v_inici timestamp; 
  entrada varchar2(500);
  RSP varchar2(200);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := 'competicio_id = '||p_competicio_id||' temporada_id = '||p_temporada_id;
    -- S'actualitza: after insert or update on estadistiques_p_j, contracte, competicio, partit, equip
    Select c.equip_comprador_id, e.equip, max(es.ro) Into millor_o_id, millor_o, n From estadistiques_p_j es, contracte c, competicio co, partit p, equip e Where
      es.jugador_id = c.jugador_id -- estadstica i contracte del mateix jugador
      And c.ultim = 1 -- i el contracte s l'ltim del jugador, s'obt l'equip del jugador
      And co.competicio_id = p_competicio_id
      And co.competicio_id = p.competicio_id -- partits de la competici
      And co.temporada_id = p_temporada_id
      And p.partit_id = es.partit_id -- estadstiques dels partits
      and c.equip_comprador_id = e.equip_id
      group by c.equip_comprador_id, e.equip;
    Select c.equip_comprador_id, e.equip, max(es.rd) Into millor_d_id, millor_d, n From estadistiques_p_j es, contracte c, competicio co, partit p, equip e Where
      es.jugador_id = c.jugador_id -- estadstica i contracte del mateix jugador
      And c.ultim = 1 -- i el contracte s l'ltim del jugador, s'obt l'equip del jugador
      And co.competicio_id = p_competicio_id
      And co.competicio_id = p.competicio_id -- partits de la competici
      And co.temporada_id = p_temporada_id
      And p.partit_id = es.partit_id -- estadstiques dels partits
      and c.equip_comprador_id = e.equip_id
      group by c.equip_comprador_id, e.equip;
    
    Select count(competicio_id) Into contador From m_e_c6 Where 
      competicio_id = p_competicio_id And temporada_id = p_temporada_id;
    if (contador = 0) Then
      Select competicio Into compet From competicio Where competicio_id = p_competicio_id;
      Select temporada Into temp From temporada Where temporada_id = p_temporada_id;
      INSERT INTO m_e_c6 (competicio_id, competicio, temporada_id, temporada, millor_ofensiu_id, millor_ofensiu, millor_defensiu_id, millor_defensiu) 
      VALUES (p_competicio_id, compet, p_temporada_id, temp, millor_o_id, millor_o, millor_d_id, millor_d);
    else
      Update M_E_C6 Set 
        millor_ofensiu_id = millor_o_id, 
        millor_ofensiu = millor_o, 
        millor_defensiu_id = millor_d_id, 
        millor_defensiu = millor_d
      Where
        competicio_id = p_competicio_id
        And temporada_id = p_temporada_id;
    end if;
    
    inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C6', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C6', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END actualitza_M_E_C6;
  
  
  /** NOM DEL PROCEDIMENT: millor_jugador_mon
      FUNCIONALITAT: Retorna el millor jugador del mn en el darrer any (mitjana de valoracions ponderades ms alta) per a cada gnere i modalitat.
      PARMETRES D'ENTRADA: 
      PARMETRES DE SORTIDA: Identificador del jugador, nom i mitjana de valoracions ponderades per a cada una de les modalitats i gneres.
                             RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/
  --Consulta 7. Per a cada gnere i modalitat, el millor jugador del mn en el darrer any (mitjana de valoracions ponderades ms alta).
  procedure millor_jugador_mon(
  p_j_id_m1_g1 OUT JUGADOR.JUGADOR_ID%type, p_nom_m1_g1 OUT JUGADOR.NOM%type, p_mvp_m1_g1 OUT ESTADISTIQUES_P_J.VP%type, 
  p_j_id_m1_g2 OUT JUGADOR.JUGADOR_ID%type, p_nom_m1_g2 OUT JUGADOR.NOM%type, p_mvp_m1_g2 OUT ESTADISTIQUES_P_J.VP%type, 
  p_j_id_m2_g1 OUT JUGADOR.JUGADOR_ID%type, p_nom_m2_g1 OUT JUGADOR.NOM%type, p_mvp_m2_g1 OUT ESTADISTIQUES_P_J.VP%type, 
  p_j_id_m2_g2 OUT JUGADOR.JUGADOR_ID%type, p_nom_m2_g2 OUT JUGADOR.NOM%type, p_mvp_m2_g2 OUT ESTADISTIQUES_P_J.VP%type, 
  RSP OUT varchar2) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := '';
    Select j_id_m1_g1, nom_m1_g1, mvp_m1_g1, 
      j_id_m1_g2, nom_m1_g2, mvp_m1_g2, 
      j_id_m2_g1, nom_m2_g1, mvp_m2_g1, 
      j_id_m2_g2, nom_m2_g2, mvp_m2_g2 
    Into p_j_id_m1_g1, p_nom_m1_g1, p_mvp_m1_g1, 
      p_j_id_m1_g2, p_nom_m1_g2, p_mvp_m1_g2, 
      p_j_id_m2_g1, p_nom_m2_g1, p_mvp_m2_g1, 
      p_j_id_m2_g2, p_nom_m2_g2, p_mvp_m2_g2 
    From M_E_C7;
    
    inserta_log('MODUL_ESTADISTIC', 'millor_jugador_mon', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'millor_jugador_mon', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END millor_jugador_mon;


  /** NOM DEL PROCEDIMENT: actualitza_M_E_C7
      FUNCIONALITAT: Actualitza la taula del mdul estadstic que cont les dades del millor jugador del mn en el darrer any (mitjana de valoracions ponderades ms alta) per a cada gnere i modalitat.
      PARMETRES D'ENTRADA: competicio_id, identificador de la competici.
                            temporada_id, identificador de la temporada.
      PARMETRES DE SORTIDA: 
  **/
  procedure actualitza_m_e_c7 as
    j_id_m1_g1 JUGADOR.JUGADOR_ID%type;
    nom_m1_g1 JUGADOR.NOM%type;
    mvp_m1_g1 ESTADISTIQUES_P_J.VP%type;
    j_id_m1_g2 JUGADOR.JUGADOR_ID%type;
    nom_m1_g2 JUGADOR.NOM%type;
    mvp_m1_g2 ESTADISTIQUES_P_J.VP%type;
    j_id_m2_g1 JUGADOR.JUGADOR_ID%type;
    nom_m2_g1 jugador.nom%type;
    mvp_m2_g1 ESTADISTIQUES_P_J.VP%type;
    j_id_m2_g2 JUGADOR.JUGADOR_ID%type;
    nom_m2_g2 JUGADOR.NOM%type;
    mvp_m2_g2 ESTADISTIQUES_P_J.VP%type;
    n number;
  v_inici timestamp; 
  entrada varchar2(500); 
  RSP varchar2(200);
  BEGIN
    v_inici := systimestamp;
    RSP := 'OK';
    entrada := '';
    -- S'actualitza: after insert or update on estadistiques_p_j, partit, competicio, temporada, jugador
    Select es.jugador_id, j.nom, max(sum(es.vp)/count(es.estadistica_id)) Into j_id_m1_g1, nom_m1_g1, mvp_m1_g1 From estadistiques_p_j es, partit p, competicio co, temporada t, jugador j Where 
      j.genere_id = 1
      And j.modalitat_id = 1
      And es.partit_id = p.partit_id -- partits de les estadstiques
      And p.competicio_id = co.competicio_id -- competici del partit
      And co.temporada_id = t.temporada_id
      And t.temporada_actual = 1
      and es.jugador_id = j.jugador_id -- jugador de l'estadstica
      group by es.jugador_id, j.nom;
    Select es.jugador_id, j.nom, max(sum(es.vp)/count(es.estadistica_id)) Into j_id_m1_g2, nom_m1_g2, mvp_m1_g2 From estadistiques_p_j es, partit p, competicio co, temporada t, jugador j Where 
      j.genere_id = 1
      And j.modalitat_id = 2
      And es.partit_id = p.partit_id -- partits de les estadstiques
      And p.competicio_id = co.competicio_id -- competici del partit
      And co.temporada_id = t.temporada_id
      And t.temporada_actual = 1
      and es.jugador_id = j.jugador_id -- jugador de l'estadstica
      group by es.jugador_id, j.nom;
    Select es.jugador_id, j.nom, max(sum(es.vp)/count(es.estadistica_id)) Into j_id_m2_g1, nom_m2_g1, mvp_m2_g1 From estadistiques_p_j es, partit p, competicio co, temporada t, jugador j Where 
      j.genere_id = 2
      And j.modalitat_id = 1
      And es.partit_id = p.partit_id -- partits de les estadstiques
      And p.competicio_id = co.competicio_id -- competici del partit
      And co.temporada_id = t.temporada_id
      And t.temporada_actual = 1
      and es.jugador_id = j.jugador_id -- jugador de l'estadstica
      group by es.jugador_id, j.nom;
    Select es.jugador_id, j.nom, max(sum(es.vp)/count(es.estadistica_id)) Into j_id_m2_g2, nom_m2_g2, mvp_m2_g2 From estadistiques_p_j es, partit p, competicio co, temporada t, jugador j Where 
      j.genere_id = 2
      And j.modalitat_id = 2
      And es.partit_id = p.partit_id -- partits de les estadstiques
      And p.competicio_id = co.competicio_id -- competici del partit
      And co.temporada_id = t.temporada_id
      And t.temporada_actual = 1
      and es.jugador_id = j.jugador_id -- jugador de l'estadstica
      group by es.jugador_id, j.nom;
      
    Update M_E_C7 Set 
      j_id_m1_g1 = j_id_m1_g1, 
      nom_m1_g1 = nom_m1_g1, 
      mvp_m1_g1 = mvp_m1_g1, 
      j_id_m1_g2 = j_id_m1_g2, 
      nom_m1_g2 = nom_m1_g2, 
      mvp_m1_g2 = mvp_m1_g2, 
      j_id_m2_g1 = j_id_m2_g1, 
      nom_m2_g1 = nom_m2_g1, 
      mvp_m2_g1 = mvp_m2_g1, 
      j_id_m2_g2 = j_id_m2_g2, 
      nom_m2_g2 = nom_m2_g2, 
      mvp_m2_g2 = mvp_m2_g2;
      
    inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C7', entrada, RSP, v_inici, systimestamp);
    
  EXCEPTION
    WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE ('ERROR '||SQLCODE||SQLERRM);
      RSP := 'ERROR '||sqlerrm;
      inserta_log('MODUL_ESTADISTIC', 'actualitza_M_E_C7', entrada, RSP, v_inici, systimestamp);
      -- raise_application_error (-20001, SQLERRM);
  END actualitza_M_E_C7;


  /** NOM DEL PROCEDIMENT: taula_jugador_canviada
      FUNCIONALITAT: Quan el trigger detecta insert or update on jugador aquest procediment fa les operacions d'actualitzaci del mdul estadstic.
      PARMETRES D'ENTRADA: jugador_id, identificador del jugador.
                            temporada_id, identificador de la temporada.
                            federacio_id, identificador de la federaci.
                            genere_id, identificador del gnere.
                            modalitat_id, identificador de la modalitat.
      PARMETRES DE SORTIDA: 
  **/
  procedure taula_jugador_canviada(
    p_temporada temporada.temporada_id%type, 
    p_federacio_id jugador.federacio_id%type, 
    p_genere_id jugador.genere_id%type, 
    p_modalitat_id jugador.modalitat_id%type) as
  begin
    /*modul_estadistic.actualitza_M_E_C1();
    modul_estadistic.actualitza_m_e_c3();
    modul_estadistic.actualitza_M_E_C4();
    modul_estadistic.actualitza_m_e_c5(p_federacio_id, p_temporada, p_genere_id, p_modalitat_id);
    modul_estadistic.actualitza_M_E_C7();    */
    null;
  END taula_jugador_canviada;


  /** NOM DEL PROCEDIMENT: inserta_log
      FUNCIONALITAT: Permet fer un registre dels procediments cridats, els parmetres d'entrada i els de sortida
      PARMETRES D'ENTRADA: paquet del procediment que crida al log
                            procediment que crida al log
                            entrada: parmetres d'entrada al procediment que crida al log
                            sortida: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
                            inici: moment en que comena el procediment que crida al log
                            final: moment en que acaba el procediment que crida al log
      PARMETRES DE SORTIDA: RSP, indica si l'execuci ha finalitzat amb xit (valor 'OK') o no (valor 'ERROR + TIPUS D'ERROR')
  **/  
  procedure inserta_log(
    p_paquet IN varchar2, 
    p_procediment IN varchar2, 
    p_entrada IN varchar2, 
    p_sortida IN varchar2, 
    p_inici IN timestamp, 
    p_final IN timestamp) AS
  v_inici timestamp; 
  entrada varchar2(500); 
  BEGIN
    INSERT INTO LOG_CRIDES VALUES (seq_log_crides_id.nextval, p_paquet, p_procediment, p_entrada, p_sortida, p_inici, p_final);
    
    EXCEPTION
      WHEN OTHERS THEN
        raise_application_error (-20001, SQLERRM);
  END inserta_log;  
END MODUL_ESTADISTIC;

/
--------------------------------------------------------
--  DDL for Procedure ORA$_SYS_REP_AUTH
--------------------------------------------------------
set define off;

  CREATE OR REPLACE PROCEDURE "SYSTEM"."ORA$_SYS_REP_AUTH" as
begin
  EXECUTE IMMEDIATE 'GRANT SELECT ON SYSTEM.repcat$_repschema TO SYS ' ||
                 'WITH GRANT OPTION';
  EXECUTE IMMEDIATE 'GRANT SELECT ON SYSTEM.repcat$_repprop TO SYS ' ||
                 'WITH GRANT OPTION';
  EXECUTE IMMEDIATE 'GRANT SELECT ON SYSTEM.def$_aqcall TO SYS ' ||
                 'WITH GRANT OPTION';
  EXECUTE IMMEDIATE 'GRANT SELECT ON SYSTEM.def$_calldest TO SYS ' ||
                 'WITH GRANT OPTION';
  EXECUTE IMMEDIATE 'GRANT SELECT ON SYSTEM.def$_error TO SYS ' ||
                 'WITH GRANT OPTION';
  EXECUTE IMMEDIATE 'GRANT SELECT ON SYSTEM.def$_destination TO SYS ' ||
                 'WITH GRANT OPTION';
end;

/
